
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb OCDR=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

#pragma used+

signed char cmax(signed char a,signed char b);
int max(int a,int b);
long lmax(long a,long b);
float fmax(float a,float b);
signed char cmin(signed char a,signed char b);
int min(int a,int b);
long lmin(long a,long b);
float fmin(float a,float b);
signed char csign(signed char x);
signed char sign(int x);
signed char lsign(long x);
signed char fsign(float x);
unsigned char isqrt(unsigned int x);
unsigned int lsqrt(unsigned long x);
float sqrt(float x);
float floor(float x);
float ceil(float x);
float fmod(float x,float y);
float modf(float x,float *ipart);
float ldexp(float x,int expon);
float frexp(float x,int *expon);
float exp(float x);
float log(float x);
float log10(float x);
float pow(float x,float y);
float sin(float x);
float cos(float x);
float tan(float x);
float sinh(float x);
float cosh(float x);
float tanh(float x);
float asin(float x);
float acos(float x);
float atan(float x);
float atan2(float y,float x);

#pragma used-
#pragma library math.lib

#asm
   .equ __lcd_port=0x1B ;PORTA
#endasm

#pragma used+

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);

void lcd_write_byte(unsigned char addr, unsigned char data);

unsigned char lcd_read_byte(unsigned char addr);

void lcd_gotoxy(unsigned char x, unsigned char y);

void lcd_clear(void);
void lcd_putchar(char c);

void lcd_puts(char *str);

void lcd_putsf(char flash *str);

unsigned char lcd_init(unsigned char lcd_columns);

void lcd_control (unsigned char control);

#pragma used-
#pragma library lcd.lib

unsigned char Ok=27, Down=29, Up=30;

eeprom float P2=6.283185307180;
eeprom float DR=0.017453292520;
eeprom float K1=0.262516089803;
eeprom unsigned char days_month[12]={31,28,31,30,31,30,31,31,30,31,30,31};

long int  Y=2009, M=1, H=-3, B5=69, J3, H3, M3, C0;

long int MM[2], HH[2];

int hr, mins, sec, msec, cc = 0, day=1;

float aA[2], aD[2];

float L5, Z, Z0, Z1, D, A5, D5, R5, T, T0, TT, T3, L0, L2, H0, H1, H2, lat=33,
M8, W8, A, B, A0, D0, A2, D1, D2, DA, DD, E, F, J, S, C, P, L, G, V, U, W, V0, V1, V2;

unsigned char key=31;

char delim=':';

bit st;

interrupt [10] void timer0_ovf_isr(void)
{
cc++;
if (cc>=1) {msec++; cc=0;};

}

interrupt [5] void timer2_ovf_isr(void)
{
key=PINB; 
}

void me_delay(void)
{
delay_ms(200); 
key=0;
}

void cld_cls(void)
{
lcd_gotoxy(0,0);
lcd_putsf("               ");
HH[0]=0; MM[0]=0;
HH[1]=0; MM[1]=0;
}

float Abs(float x)
{
return( x<0 ?-x:x);
}

int Sgn(float x)
{  
return( x>=0 ?1:-1);
}

long int Trunc (float x)
{
if (x>=0) {x=floor(x);}
else {x=ceil(x);}
return (long int)x;
}

void sun_info()
{ int i;
for (i=0; i<2; i++)
{
lcd_gotoxy(6*i,0);
lcd_putchar (HH[i]/10%10+0x30);
lcd_putchar (HH[i]%10+0x30);
lcd_putchar (':');
lcd_putchar (MM[i]/10%10+0x30);
lcd_putchar (MM[i]%10+0x30);
}
}

void Calendar(void)
{
G = 1;
if (Y < 1583) {G = 0;};
D1 = Trunc(D);
F = D - D1 - 0.5;
J = -Trunc(7 * (Trunc((M + 9) / 12) + Y) / 4);
if (G == 1)
{
S = Sgn(M - 9);
A = Abs(M - 9);
J3 = Trunc(Y + S * Trunc(A / 7));
J3 =( -(((J3 / 100) + 1) * 3 / 4));
}
J = J + Trunc(275 * M / 9) + D1 + G * J3;
J = J + 1721027 + 2 * G + 367 * Y;
if (F >= 0) {goto end1;};
F = F + 1;
J = J - 1;
end1:
}

void GetTimeZone(void)
{
T0 = T / 36525;
S = 24110.5 + 8640184.813 * T0;
S = S + 86636.6 * Z0 + 86400 * L5;
S = S / 86400;
S = S - Trunc(S);
T0 = S * 360 * DR;
}

void PosOfSun(void)
{

L = 0.779072 + 0.00273790931 * T;
G = 0.993126 + 0.0027377785 * T;
L = L - Trunc(L);
G = G - Trunc(G);
L = L * P2;
G = G * P2;
V = 0.39785 * sin(L);
V = V - 0.01000 * sin(L - G);
V = V + 0.00333 * sin(L + G);
V = V - 0.00021 * TT * sin(L);
U = 1 - 0.03349 * cos(G);
U = U - 0.00014 * cos(2 * L);
U = U + 0.00008 * cos(L);
W = -0.00010 - 0.04129 * sin(2 * L);
W = W + 0.03211 * sin(G);
W = W + 0.00104 * sin(2 * L - G);
W = W - 0.00035 * sin(2 * L + G);
W = W - 0.00008 * TT * sin(G);
S = W / sqrt(U - V * V);
A5 = L + atan(S / sqrt(1 - S * S));
S = V / sqrt(U);
D5 = atan(S / sqrt(1 - S * S));
R5 = 1.00021 * sqrt(U);
}

void PossibleEvents(int Hour)
{
st = 0;
L0 = T0 + Hour * K1;
L2 = L0 + K1;
H0 = L0 - A0;
H2 = L2 - A2;
H1 = (H2 + H0) / 2; 
D1 = (D2 + D0) / 2; 
if (Hour <= 0) {V0 = S * sin(D0) + C * cos(D0) * cos(H0) - Z;}
V2 = S * sin(D2) + C * cos(D2) * cos(H2) - Z;
if (Sgn(V0) == Sgn(V2)) {goto end2;}
V1 = S * sin(D1) + C * cos(D1) * cos(H1) - Z;
A = 2 * V2 - 4 * V1 + 2 * V0;
B = 4 * V1 - 3 * V0 - V2;
D = B * B - 4 * A * V0;
if (D < 0) {goto end2;};
D = sqrt(D);
E = (-B + D) / (2 * A);
if ((E > 1) || (E < 0)) {E = (-B - D) / (2 * A);}
T3 = Hour + E + 1 / 120; 
H3 = Trunc(T3);
M3 = Trunc((T3 - H3) * 60);
if ((V0 < 0) && (V2 > 0)) {HH[0]=H3; MM[0]=M3; M8 = 1; st=1;};
if ((V0 > 0) && (V2 < 0)) {HH[1]=H3; MM[1]=M3; W8 = 1; st=1;};
end2:
}

void OutInform(void)
{
if ((M8 == 0) && (W8 == 0))
{  
if (V2 < 0) {st=0; cld_cls();}

if (V2 > 0) {st=0; cld_cls();}

}
else
{
if (M8 == 0) {st=0; cld_cls();} 

if (W8 == 0) {st=0; cld_cls();} 

}
}

void show_info(void)
{ 
D = day;
L5=lat;
L5 = L5 / 360;
Z0 = (float) H / 24;
Calendar();
T = (J - 2451545) + F;
TT = T / 36525 + 1; 
GetTimeZone(); 
T = T + Z0;
PosOfSun(); 
aA[0] = A5;
aD[0] = D5;
T = T + 1;
PosOfSun();
aA[1] = A5;
aD[1] = D5;
if (aA[1] < aA[0]) {aA[1] = aA[1] + P2;}
Z1 = DR * 90.833; 
S = sin(B5 * DR);
C = cos(B5 * DR);
Z = cos(Z1);
M8 = 0;
W8 = 0;
A0 = aA[0];
D0 = aD[0];
DA = aA[1] - aA[0];
DD = aD[1] - aD[0];
for (C0 = 0; C0 < 24; C0++)
{
P = ((float)C0 + 1) / 24;
A2 = aA[0] + P * DA;
D2 = aD[0] + P * DD;
PossibleEvents(C0);
if (st != 0) {sun_info();}
A0 = A2;
D0 = D2;
V0 = V2;
}
OutInform();
}

void display(void)
{ unsigned int i;
lcd_gotoxy(13,0);
lcd_putsf("Z");
i=Trunc(Abs(H));
lcd_putchar (i/10%10+0x30);
lcd_putchar (i%10+0x30);
lcd_gotoxy(0,1);
lcd_putchar (hr/10%10+0x30);
lcd_putchar (hr%10+0x30);
lcd_putchar (delim);
lcd_putchar (mins/10%10+0x30);
lcd_putchar (mins%10+0x30);
lcd_putsf (" ");
lcd_putchar ((day/10)%10+0x30);
lcd_putchar (day%10+0x30);
lcd_putsf ("/");
lcd_putchar ((M/10)%10+0x30);
lcd_putchar (M%10+0x30);
lcd_putsf ("/");
lcd_putchar ((Y/1000)%10+0x30);
lcd_putchar ((Y/100)%10+0x30);
lcd_putchar ((Y/10)%10+0x30);
lcd_putchar (Y%10+0x30);
}

void clock(void)
{ unsigned char qty_days;
if (msec>=150) 
{
msec=0; sec++; 
if (delim==':') {delim=' ';} 
else {delim=':';};
}; 
if (sec==60) {sec=0; mins++;};
if (mins==60) {mins=0; hr++;};
if (hr==24) {day++; hr=0; show_info();};
qty_days=days_month[M-1];
if ((M==2) && (Y%4)==(Y/4)) {qty_days=29;}
if (day==qty_days) {M++; day=1;};
if (M==12) {M=1; Y++;};
display();
if ((HH[0]!=HH[1]) && (MM[0]!=MM[1]))
{
if ((hr*60+mins)>(HH[0]*60+MM[0])) {st=1;};
if ((hr*60+mins)>(HH[1]*60+MM[1])) {st=0;};
}
if (st==0) {PORTC.0=1;;} else
if (st==1) {PORTC.0=0;;}
}

void main(void)
{
unsigned int tmp;

PORTA=0x00;
DDRA=0xF7;

PORTB=0x1F;
DDRB=0x00;

PORTC=0x00;
DDRC=0x01;

PORTD=0x00;
DDRD=0x00;

TCCR0=0x02;
TCNT0=0x00;
OCR0=0x00;

TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

ASSR=0x00;
TCCR2=0x07;
TCNT2=0x00;
OCR2=0x00;

MCUCR=0x00;
MCUCSR=0x00;

TIMSK=0x41;

ACSR=0x80;
SFIOR=0x00;

lcd_init(16);

#asm("sei")

lcd_gotoxy(0,0);
lcd_putsf(" = Auto Light = ");
lcd_gotoxy(0,1);
lcd_putsf("    ver. 1.0    ");
while (key!=Ok){}
me_delay();

lcd_gotoxy(0,0);
lcd_putsf("Enter latitude ");
lcd_gotoxy(0,1);
lcd_putsf("                ");
while (key!=Ok)
{
lcd_gotoxy(6,1);
lcd_putchar (B5/10%10+0x30);
lcd_putchar (B5%10+0x30); 
if ((key==Up) & (B5<90)) {B5++; delay_ms(200);}
if ((key==Down) & (B5>0)) {B5--; delay_ms(200);}

}

me_delay();

lcd_gotoxy(0,0);
lcd_putsf("Enter longitude ");
lcd_gotoxy(0,1);
lcd_putsf("                ");
tmp=(int)lat;
while (key!=Ok)
{
lcd_gotoxy(6,1);
lcd_putchar (tmp/10%10+0x30);
lcd_putchar (tmp%10+0x30); 
if ((key==Up) & (tmp<180)) {tmp++; delay_ms(200);}
if ((key==Down) & (tmp>0)) {tmp--; delay_ms(200);}

}
me_delay(); 
lat=(float) tmp;

lcd_gotoxy(0,0);
lcd_putsf("Enter month  ");

while (key!=Ok)
{
display(); 
if ((key==Up) & (M<12)) {M++; delay_ms(200);}
if ((key==Down) & (M>1)) {M--; delay_ms(200);}
}
me_delay();

lcd_gotoxy(0,0);
lcd_putsf("Enter day    ");

while (key!=Ok)
{
display(); 
if ((key==Up) & (day<days_month[M])) {day++; delay_ms(200);}
if ((key==Down) & (day>1)) {day--; delay_ms(200);}
}
me_delay();

lcd_gotoxy(0,0);
lcd_putsf("Enter year   ");

while (key!=Ok)
{
display(); 
if ((key==Up) & (Y<2100)) {Y++; delay_ms(200);}
if ((key==Down) & (Y>1900)) {Y--; delay_ms(200);}
}
me_delay();

lcd_gotoxy(0,0);
lcd_putsf("Enter hours  ");

while (key!=Ok)
{
display(); 
if ((key==Up) & (hr<24)) {hr++; delay_ms(200);}
if ((key==Down) & (hr>1)) {hr--; delay_ms(200);}
}
me_delay();

lcd_gotoxy(0,0);
lcd_putsf("Enter minits ");

while (key!=Ok)
{
display(); 
if ((key==Up) & (mins<59)) {mins++; delay_ms(200);}
if ((key==Down) & (mins>1)) {mins--; delay_ms(200);}
}
me_delay();

lcd_gotoxy(0,0);
lcd_putsf("Enter zone  ");

while (key!=Ok)
{
display(); 
if ((key==Up) & (Abs(H)<12)) {H--; delay_ms(200);}
if ((key==Down) & (Abs(H)>0)) {H++; delay_ms(200);}

}

clock();
show_info();

while (1)
{

clock();
};
}
