
;CodeVisionAVR C Compiler V2.03.9 Standard
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega16
;Program type           : Application
;Clock frequency        : 12,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 128 byte(s)
;Heap size              : 128 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;global const stored in FLASH  : No
;8 bit enums            : Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega16
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _Ok=R4
	.DEF _Down=R3
	.DEF _Up=R6
	.DEF _hr=R7
	.DEF _mins=R9
	.DEF _sec=R11
	.DEF _msec=R13
	.DEF _key=R5

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer2_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer0_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

;HEAP START MARKER INITIALIZATION
__HEAP_START_MARKER:
	.DW  0,0

_0x3:
	.DB  0xD9,0x7
_0x4:
	.DB  0x1
_0x5:
	.DB  0xFD,0xFF,0xFF,0xFF
_0x6:
	.DB  0x45
_0x7:
	.DB  0x1
_0x8:
	.DB  0x0,0x0,0x4,0x42
_0x9:
	.DB  0x3A
_0x7C:
	.DB  0x1D,0x1B,0x1F,0x1E
_0x0:
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x0
	.DB  0x5A,0x0,0x2F,0x0,0x20,0x3D,0x20,0x41
	.DB  0x75,0x74,0x6F,0x20,0x4C,0x69,0x67,0x68
	.DB  0x74,0x20,0x3D,0x20,0x0,0x20,0x20,0x20
	.DB  0x20,0x76,0x65,0x72,0x2E,0x20,0x31,0x2E
	.DB  0x30,0x20,0x20,0x20,0x20,0x0,0x45,0x6E
	.DB  0x74,0x65,0x72,0x20,0x6C,0x61,0x74,0x69
	.DB  0x74,0x75,0x64,0x65,0x20,0x0,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x0,0x45
	.DB  0x6E,0x74,0x65,0x72,0x20,0x6C,0x6F,0x6E
	.DB  0x67,0x69,0x74,0x75,0x64,0x65,0x20,0x0
	.DB  0x45,0x6E,0x74,0x65,0x72,0x20,0x6D,0x6F
	.DB  0x6E,0x74,0x68,0x20,0x20,0x0,0x45,0x6E
	.DB  0x74,0x65,0x72,0x20,0x64,0x61,0x79,0x20
	.DB  0x20,0x20,0x20,0x0,0x45,0x6E,0x74,0x65
	.DB  0x72,0x20,0x79,0x65,0x61,0x72,0x20,0x20
	.DB  0x20,0x0,0x45,0x6E,0x74,0x65,0x72,0x20
	.DB  0x68,0x6F,0x75,0x72,0x73,0x20,0x20,0x0
	.DB  0x45,0x6E,0x74,0x65,0x72,0x20,0x6D,0x69
	.DB  0x6E,0x69,0x74,0x73,0x20,0x0,0x45,0x6E
	.DB  0x74,0x65,0x72,0x20,0x7A,0x6F,0x6E,0x65
	.DB  0x20,0x20,0x0
_0x2020003:
	.DB  0x80,0xC0
_0x204005F:
	.DB  0x1
_0x2040000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0

__GLOBAL_INI_TBL:
	.DW  0x04
	.DW  0x3E0
	.DW  __HEAP_START_MARKER*2

	.DW  0x02
	.DW  _Y
	.DW  _0x3*2

	.DW  0x01
	.DW  _M
	.DW  _0x4*2

	.DW  0x04
	.DW  _H
	.DW  _0x5*2

	.DW  0x01
	.DW  _B5
	.DW  _0x6*2

	.DW  0x01
	.DW  _day
	.DW  _0x7*2

	.DW  0x04
	.DW  _lat
	.DW  _0x8*2

	.DW  0x01
	.DW  _delim
	.DW  _0x9*2

	.DW  0x04
	.DW  0x03
	.DW  _0x7C*2

	.DW  0x02
	.DW  __base_y_G101
	.DW  _0x2020003*2

	.DW  0x01
	.DW  __seed_G102
	.DW  _0x204005F*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x380)
	LDI  R25,HIGH(0x380)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x3DF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x3DF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V1.25.9 Professional
;Automatic Program Generator
; Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 09.06.2008
;Author  : F4CG
;Company : F4CG
;Comments:
;
;
;Chip type           : ATmega16
;Program type        : Application
;Clock frequency     : 12,000000 MHz
;Memory model        : Small
;External SRAM size  : 0
;Data Stack size     : 256
;*****************************************************/
;
;#include <mega16.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <math.h>
;
;
;// Alphanumeric LCD Module functions
;#asm
   .equ __lcd_port=0x1B ;PORTA
; 0000 0020 #endasm
;#include <lcd.h>
;
;#define light_on PORTC.0=1;
;#define light_off PORTC.0=0;
;unsigned char Ok=27, Down=29, Up=30;
;//unsigned char Right=15, Left=11;
;
;/*flash const float P2=6.283185307180;
;flash const float DR=0.017453292520;
;flash const float K1=0.262516089803;
;flash const unsigned days_month[12]={31,28,31,30,31,30,31,31,30,31,30,31};*/
;
;eeprom float P2=6.283185307180;
;eeprom float DR=0.017453292520;
;eeprom float K1=0.262516089803;
;eeprom unsigned char days_month[12]={31,28,31,30,31,30,31,31,30,31,30,31};
;
;//char inf[2,16]=["Enter latitude "],["Enter latitude "];
;
;long int  Y=2009, M=1, H=-3, B5=69, J3, H3, M3, C0;

	.DSEG
;
;long int MM[2], HH[2];
;
;int hr, mins, sec, msec, cc = 0, day=1;
;
;float aA[2], aD[2];
;
;float L5, Z, Z0, Z1, D, A5, D5, R5, T, T0, TT, T3, L0, L2, H0, H1, H2, lat=33,
;      M8, W8, A, B, A0, D0, A2, D1, D2, DA, DD, E, F, J, S, C, P, L, G, V, U, W, V0, V1, V2;
;
;unsigned char key=31;
;
;char delim=':';
;
;bit st;
;
;
;// Timer 0 overflow interrupt service routine
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 0048 {

	.CSEG
_timer0_ovf_isr:
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0049   cc++;
	LDI  R26,LOW(_cc)
	LDI  R27,HIGH(_cc)
	CALL SUBOPT_0x0
; 0000 004A   if (cc>=1) {msec++; cc=0;};
	LDS  R26,_cc
	LDS  R27,_cc+1
	SBIW R26,1
	BRLT _0xA
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__ADDWRR 13,14,30,31
	LDI  R30,LOW(0)
	STS  _cc,R30
	STS  _cc+1,R30
_0xA:
; 0000 004B     // Place your code here
; 0000 004C }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI
;
;// Timer 2 overflow interrupt service routine
;interrupt [TIM2_OVF] void timer2_ovf_isr(void)
; 0000 0050 {
_timer2_ovf_isr:
; 0000 0051   key=PINB;
	IN   R5,22
; 0000 0052 }
	RETI
;
;void me_delay(void)
; 0000 0055 {
_me_delay:
; 0000 0056   delay_ms(200);
	CALL SUBOPT_0x1
; 0000 0057   key=0;
	CLR  R5
; 0000 0058 }
	RET
;
;void cld_cls(void)
; 0000 005B {
_cld_cls:
; 0000 005C   lcd_gotoxy(0,0);
	CALL SUBOPT_0x2
; 0000 005D   lcd_putsf("               ");
	__POINTW1FN _0x0,0
	CALL SUBOPT_0x3
; 0000 005E   HH[0]=0; MM[0]=0;
	LDI  R30,LOW(0)
	STS  _HH,R30
	STS  _HH+1,R30
	STS  _HH+2,R30
	STS  _HH+3,R30
	STS  _MM,R30
	STS  _MM+1,R30
	STS  _MM+2,R30
	STS  _MM+3,R30
; 0000 005F   HH[1]=0; MM[1]=0;
	__POINTW1MN _HH,4
	CALL SUBOPT_0x4
	__POINTW1MN _MM,4
	CALL SUBOPT_0x4
; 0000 0060 }
	RET
;
;// Declare your global variables here
;
;float Abs(float x)
; 0000 0065 {
_Abs:
; 0000 0066   return( x<0 ?-x:x);
;	x -> Y+0
	LDD  R26,Y+3
	TST  R26
	BRPL _0xB
	CALL SUBOPT_0x5
	CALL __ANEGF1
	RJMP _0xC
_0xB:
	CALL SUBOPT_0x5
_0xC:
	RJMP _0x20A0003
; 0000 0067 }
;
;
;int Sgn(float x)
; 0000 006B {
_Sgn:
; 0000 006C   return( x>=0 ?1:-1);
;	x -> Y+0
	LDD  R26,Y+3
	TST  R26
	BRMI _0xE
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0xF
_0xE:
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
_0xF:
	RJMP _0x20A0003
; 0000 006D }
;
;long int Trunc (float x)
; 0000 0070 {
_Trunc:
; 0000 0071   if (x>=0) {x=floor(x);}
;	x -> Y+0
	LDD  R26,Y+3
	TST  R26
	BRMI _0x11
	CALL SUBOPT_0x6
	CALL _floor
	RJMP _0x7A
; 0000 0072   else {x=ceil(x);}
_0x11:
	CALL SUBOPT_0x6
	CALL _ceil
_0x7A:
	__PUTD1S 0
; 0000 0073   return (long int)x;
	CALL SUBOPT_0x5
	CALL __CFD1
_0x20A0003:
	ADIW R28,4
	RET
; 0000 0074 }
;
;void sun_info()
; 0000 0077 { int i;
_sun_info:
; 0000 0078   for (i=0; i<2; i++)
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	__GETWRN 16,17,0
_0x14:
	__CPWRN 16,17,2
	BRGE _0x15
; 0000 0079   {
; 0000 007A     lcd_gotoxy(6*i,0);
	MOVW R30,R16
	LDI  R26,LOW(6)
	LDI  R27,HIGH(6)
	CALL __MULW12
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _lcd_gotoxy
; 0000 007B     lcd_putchar (HH[i]/10%10+0x30);
	CALL SUBOPT_0x7
	CALL SUBOPT_0x8
; 0000 007C     lcd_putchar (HH[i]%10+0x30);
	CALL SUBOPT_0x7
	CALL SUBOPT_0x9
; 0000 007D     lcd_putchar (':');
	LDI  R30,LOW(58)
	ST   -Y,R30
	CALL _lcd_putchar
; 0000 007E     lcd_putchar (MM[i]/10%10+0x30);
	CALL SUBOPT_0xA
	CALL SUBOPT_0x8
; 0000 007F     lcd_putchar (MM[i]%10+0x30);
	CALL SUBOPT_0xA
	CALL SUBOPT_0x9
; 0000 0080   }
	__ADDWRN 16,17,1
	RJMP _0x14
_0x15:
; 0000 0081 }
	LD   R16,Y+
	LD   R17,Y+
	RET
;
;void Calendar(void)
; 0000 0084 {
_Calendar:
; 0000 0085   G = 1;
	CALL SUBOPT_0xB
	CALL SUBOPT_0xC
; 0000 0086   if (Y < 1583) {G = 0;};
	CALL SUBOPT_0xD
	__CPD2N 0x62F
	BRGE _0x16
	LDI  R30,LOW(0)
	STS  _G,R30
	STS  _G+1,R30
	STS  _G+2,R30
	STS  _G+3,R30
_0x16:
; 0000 0087   D1 = Trunc(D);
	CALL SUBOPT_0xE
	CALL SUBOPT_0xF
	LDI  R26,LOW(_D1)
	LDI  R27,HIGH(_D1)
	CALL __CDF1
	CALL __PUTDP1
; 0000 0088   F = D - D1 - 0.5;
	CALL SUBOPT_0x10
	CALL SUBOPT_0xE
	CALL __SUBF12
	MOVW R26,R30
	MOVW R24,R22
	CALL SUBOPT_0x11
	CALL SUBOPT_0x12
	CALL SUBOPT_0x13
; 0000 0089   J = -Trunc(7 * (Trunc((M + 9) / 12) + Y) / 4);
	CALL SUBOPT_0x14
	__ADDD1N 9
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xC
	CALL SUBOPT_0x15
	CALL SUBOPT_0xD
	CALL __ADDD12
	__GETD2N 0x7
	CALL SUBOPT_0x16
	CALL SUBOPT_0x15
	CALL __ANEGD1
	LDI  R26,LOW(_J)
	LDI  R27,HIGH(_J)
	CALL __CDF1
	CALL __PUTDP1
; 0000 008A   if (G == 1)
	CALL SUBOPT_0x17
	__CPD2N 0x3F800000
	BREQ PC+3
	JMP _0x17
; 0000 008B   {
; 0000 008C     S = Sgn(M - 9);
	CALL SUBOPT_0x18
	RCALL _Sgn
	LDI  R26,LOW(_S)
	LDI  R27,HIGH(_S)
	CALL SUBOPT_0x19
; 0000 008D     A = Abs(M - 9);
	CALL SUBOPT_0x18
	RCALL _Abs
	CALL SUBOPT_0x1A
; 0000 008E     J3 = Trunc(Y + S * Trunc(A / 7));
	LDS  R26,_A
	LDS  R27,_A+1
	LDS  R24,_A+2
	LDS  R25,_A+3
	__GETD1N 0x40E00000
	CALL __DIVF21
	CALL SUBOPT_0xF
	CALL SUBOPT_0x1B
	CALL __CDF1
	CALL __MULF12
	CALL SUBOPT_0xD
	CALL __CDF2
	CALL __ADDF12
	CALL SUBOPT_0xF
	CALL SUBOPT_0x1C
; 0000 008F     J3 =( -(((J3 / 100) + 1) * 3 / 4));
	LDS  R26,_J3
	LDS  R27,_J3+1
	LDS  R24,_J3+2
	LDS  R25,_J3+3
	__GETD1N 0x64
	CALL __DIVD21
	__ADDD1N 1
	__GETD2N 0x3
	CALL SUBOPT_0x16
	CALL __DIVD21
	CALL __ANEGD1
	CALL SUBOPT_0x1C
; 0000 0090   }
; 0000 0091   J = J + Trunc(275 * M / 9) + D1 + G * J3;
_0x17:
	CALL SUBOPT_0x14
	__GETD2N 0x113
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x9
	CALL SUBOPT_0x15
	CALL SUBOPT_0x1D
	CALL __CDF1
	CALL __ADDF12
	CALL SUBOPT_0x10
	CALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_J3
	LDS  R31,_J3+1
	LDS  R22,_J3+2
	LDS  R23,_J3+3
	CALL SUBOPT_0x17
	CALL __CDF1
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x1E
; 0000 0092   J = J + 1721027 + 2 * G + 367 * Y;
	LDS  R30,_J
	LDS  R31,_J+1
	LDS  R22,_J+2
	LDS  R23,_J+3
	__GETD2N 0x49D21618
	CALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x1F
	CALL SUBOPT_0x20
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_Y
	LDS  R31,_Y+1
	LDS  R22,_Y+2
	LDS  R23,_Y+3
	__GETD2N 0x16F
	CALL __MULD12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __CDF1
	CALL SUBOPT_0x1E
; 0000 0093   if (F >= 0) {goto end1;};
	LDS  R26,_F+3
	TST  R26
	BRPL _0x19
; 0000 0094   F = F + 1;
	LDS  R30,_F
	LDS  R31,_F+1
	LDS  R22,_F+2
	LDS  R23,_F+3
	CALL SUBOPT_0x21
	CALL __ADDF12
	CALL SUBOPT_0x13
; 0000 0095   J = J - 1;
	CALL SUBOPT_0x1D
	CALL SUBOPT_0x22
	STS  _J,R30
	STS  _J+1,R31
	STS  _J+2,R22
	STS  _J+3,R23
; 0000 0096 end1:
_0x19:
; 0000 0097 }
	RET
;
;void GetTimeZone(void)
; 0000 009A {
_GetTimeZone:
; 0000 009B   T0 = T / 36525;
	CALL SUBOPT_0x23
	CALL SUBOPT_0x24
; 0000 009C   S = 24110.5 + 8640184.813 * T0;
	LDS  R30,_T0
	LDS  R31,_T0+1
	LDS  R22,_T0+2
	LDS  R23,_T0+3
	__GETD2N 0x4B03D6B9
	CALL __MULF12
	__GETD2N 0x46BC5D00
	CALL SUBOPT_0x25
; 0000 009D   S = S + 86636.6 * Z0 + 86400 * L5;
	CALL SUBOPT_0x26
	__GETD2N 0x47A9364D
	CALL __MULF12
	CALL SUBOPT_0x1B
	CALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_L5
	LDS  R31,_L5+1
	LDS  R22,_L5+2
	LDS  R23,_L5+3
	__GETD2N 0x47A8C000
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x25
; 0000 009E   S = S / 86400;
	CALL SUBOPT_0x1B
	__GETD1N 0x47A8C000
	CALL SUBOPT_0x27
; 0000 009F   S = S - Trunc(S);
	CALL SUBOPT_0xF
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x28
	CALL SUBOPT_0x29
; 0000 00A0   T0 = S * 360 * DR;
	CALL SUBOPT_0x1B
	__GETD1N 0x43B40000
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x2A
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __MULF12
	CALL SUBOPT_0x24
; 0000 00A1 }
	RET
;
;void PosOfSun(void)
; 0000 00A4 {
_PosOfSun:
; 0000 00A5 
; 0000 00A6   //       
; 0000 00A7   //  (Van Flandern & Pulkkinen, 1979)
; 0000 00A8   L = 0.779072 + 0.00273790931 * T;
	CALL SUBOPT_0x2B
	__GETD2N 0x3B336E7F
	CALL __MULF12
	__GETD2N 0x3F477143
	CALL __ADDF12
	CALL SUBOPT_0x2C
; 0000 00A9   G = 0.993126 + 0.0027377785 * T;
	CALL SUBOPT_0x2B
	__GETD2N 0x3B336C4D
	CALL __MULF12
	__GETD2N 0x3F7E3D81
	CALL __ADDF12
	CALL SUBOPT_0x2D
; 0000 00AA   L = L - Trunc(L);
	CALL SUBOPT_0xF
	CALL SUBOPT_0x2E
	CALL SUBOPT_0x28
	CALL SUBOPT_0x2C
; 0000 00AB   G = G - Trunc(G);
	CALL SUBOPT_0x1F
	CALL SUBOPT_0xF
	CALL SUBOPT_0x17
	CALL SUBOPT_0x28
	CALL SUBOPT_0xC
; 0000 00AC   L = L * P2;
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x2E
	CALL __MULF12
	CALL SUBOPT_0x2C
; 0000 00AD   G = G * P2;
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x17
	CALL __MULF12
	CALL SUBOPT_0x2D
; 0000 00AE   V = 0.39785 * sin(L);
	CALL SUBOPT_0x30
	__GETD2N 0x3ECBB2FF
	CALL __MULF12
	CALL SUBOPT_0x31
; 0000 00AF   V = V - 0.01000 * sin(L - G);
	CALL SUBOPT_0x17
	CALL SUBOPT_0x32
	CALL SUBOPT_0x33
	__GETD2N 0x3C23D70A
	CALL SUBOPT_0x34
	CALL SUBOPT_0x12
	CALL SUBOPT_0x31
; 0000 00B0   V = V + 0.00333 * sin(L + G);
	CALL SUBOPT_0x1F
	CALL SUBOPT_0x2E
	CALL __ADDF12
	CALL SUBOPT_0x30
	__GETD2N 0x3B5A3C21
	CALL SUBOPT_0x34
	CALL __ADDF12
	CALL SUBOPT_0x31
; 0000 00B1   V = V - 0.00021 * TT * sin(L);
	CALL SUBOPT_0x35
	__GETD2N 0x395C3372
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x32
	CALL SUBOPT_0x30
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x34
	CALL SUBOPT_0x12
	CALL SUBOPT_0x31
; 0000 00B2   U = 1 - 0.03349 * cos(G);
	CALL SUBOPT_0x1F
	CALL SUBOPT_0x36
	__GETD2N 0x3D092CCF
	CALL SUBOPT_0x37
	CALL SUBOPT_0x38
; 0000 00B3   U = U - 0.00014 * cos(2 * L);
	CALL SUBOPT_0x20
	CALL SUBOPT_0x36
	__GETD2N 0x3912CCF7
	CALL SUBOPT_0x39
	CALL SUBOPT_0x12
	CALL SUBOPT_0x38
; 0000 00B4   U = U + 0.00008 * cos(L);
	CALL SUBOPT_0x36
	__GETD2N 0x38A7C5AC
	CALL SUBOPT_0x39
	CALL __ADDF12
	CALL SUBOPT_0x38
; 0000 00B5   W = -0.00010 - 0.04129 * sin(2 * L);
	CALL SUBOPT_0x20
	CALL SUBOPT_0x30
	__GETD2N 0x3D291FB4
	CALL __MULF12
	__GETD2N 0xB8D1B717
	CALL SUBOPT_0x12
	CALL SUBOPT_0x3A
; 0000 00B6   W = W + 0.03211 * sin(G);
	CALL SUBOPT_0x1F
	CALL SUBOPT_0x30
	__GETD2N 0x3D0385C6
	CALL SUBOPT_0x3B
; 0000 00B7   W = W + 0.00104 * sin(2 * L - G);
	CALL SUBOPT_0x17
	CALL SUBOPT_0x33
	__GETD2N 0x3A88509C
	CALL SUBOPT_0x3B
; 0000 00B8   W = W - 0.00035 * sin(2 * L + G);
	CALL SUBOPT_0x17
	CALL __ADDF12
	CALL SUBOPT_0x30
	__GETD2N 0x39B78034
	CALL SUBOPT_0x3C
	CALL SUBOPT_0x3A
; 0000 00B9   W = W - 0.00008 * TT * sin(G);
	CALL SUBOPT_0x35
	__GETD2N 0x38A7C5AC
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x1F
	CALL SUBOPT_0x30
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x3C
	CALL SUBOPT_0x3A
; 0000 00BA   S = W / sqrt(U - V * V);
	LDS  R30,_V
	LDS  R31,_V+1
	LDS  R22,_V+2
	LDS  R23,_V+3
	CALL SUBOPT_0x3D
	CALL SUBOPT_0x39
	CALL SUBOPT_0x12
	CALL SUBOPT_0x3E
	LDS  R26,_W
	LDS  R27,_W+1
	LDS  R24,_W+2
	LDS  R25,_W+3
	CALL SUBOPT_0x27
; 0000 00BB   A5 = L + atan(S / sqrt(1 - S * S));
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x37
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x3F
	CALL SUBOPT_0x2E
	CALL __ADDF12
	STS  _A5,R30
	STS  _A5+1,R31
	STS  _A5+2,R22
	STS  _A5+3,R23
; 0000 00BC   S = V / sqrt(U);
	CALL SUBOPT_0x40
	CALL SUBOPT_0x3D
	CALL SUBOPT_0x27
; 0000 00BD   D5 = atan(S / sqrt(1 - S * S));
	CALL SUBOPT_0x1B
	CALL SUBOPT_0x37
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x3F
	STS  _D5,R30
	STS  _D5+1,R31
	STS  _D5+2,R22
	STS  _D5+3,R23
; 0000 00BE   R5 = 1.00021 * sqrt(U);
	CALL SUBOPT_0x40
	__GETD2N 0x3F8006E2
	CALL __MULF12
	STS  _R5,R30
	STS  _R5+1,R31
	STS  _R5+2,R22
	STS  _R5+3,R23
; 0000 00BF }
	RET
;
;
;void PossibleEvents(int Hour)
; 0000 00C3 {
_PossibleEvents:
; 0000 00C4   st = 0;
;	Hour -> Y+0
	CLT
	BLD  R2,0
; 0000 00C5   L0 = T0 + Hour * K1;
	LDI  R26,LOW(_K1)
	LDI  R27,HIGH(_K1)
	CALL __EEPROMRDD
	CALL SUBOPT_0x41
	CALL __MULF12
	LDS  R26,_T0
	LDS  R27,_T0+1
	LDS  R24,_T0+2
	LDS  R25,_T0+3
	CALL __ADDF12
	STS  _L0,R30
	STS  _L0+1,R31
	STS  _L0+2,R22
	STS  _L0+3,R23
; 0000 00C6   L2 = L0 + K1;
	LDI  R26,LOW(_K1)
	LDI  R27,HIGH(_K1)
	CALL __EEPROMRDD
	LDS  R26,_L0
	LDS  R27,_L0+1
	LDS  R24,_L0+2
	LDS  R25,_L0+3
	CALL __ADDF12
	STS  _L2,R30
	STS  _L2+1,R31
	STS  _L2+2,R22
	STS  _L2+3,R23
; 0000 00C7   H0 = L0 - A0;
	LDS  R26,_A0
	LDS  R27,_A0+1
	LDS  R24,_A0+2
	LDS  R25,_A0+3
	LDS  R30,_L0
	LDS  R31,_L0+1
	LDS  R22,_L0+2
	LDS  R23,_L0+3
	CALL __SUBF12
	STS  _H0,R30
	STS  _H0+1,R31
	STS  _H0+2,R22
	STS  _H0+3,R23
; 0000 00C8   H2 = L2 - A2;
	LDS  R26,_A2
	LDS  R27,_A2+1
	LDS  R24,_A2+2
	LDS  R25,_A2+3
	LDS  R30,_L2
	LDS  R31,_L2+1
	LDS  R22,_L2+2
	LDS  R23,_L2+3
	CALL __SUBF12
	STS  _H2,R30
	STS  _H2+1,R31
	STS  _H2+2,R22
	STS  _H2+3,R23
; 0000 00C9   H1 = (H2 + H0) / 2; //  ,
	CALL SUBOPT_0x42
	LDS  R26,_H2
	LDS  R27,_H2+1
	LDS  R24,_H2+2
	LDS  R25,_H2+3
	CALL SUBOPT_0x43
	STS  _H1,R30
	STS  _H1+1,R31
	STS  _H1+2,R22
	STS  _H1+3,R23
; 0000 00CA   D1 = (D2 + D0) / 2; //   
	CALL SUBOPT_0x44
	LDS  R26,_D2
	LDS  R27,_D2+1
	LDS  R24,_D2+2
	LDS  R25,_D2+3
	CALL SUBOPT_0x43
	STS  _D1,R30
	STS  _D1+1,R31
	STS  _D1+2,R22
	STS  _D1+3,R23
; 0000 00CB   if (Hour <= 0) {V0 = S * sin(D0) + C * cos(D0) * cos(H0) - Z;}
	LD   R26,Y
	LDD  R27,Y+1
	CALL __CPW02
	BRLT _0x1A
	CALL SUBOPT_0x44
	CALL SUBOPT_0x30
	CALL SUBOPT_0x45
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x44
	CALL SUBOPT_0x36
	CALL SUBOPT_0x46
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x42
	CALL SUBOPT_0x36
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x47
	CALL SUBOPT_0x48
; 0000 00CC   V2 = S * sin(D2) + C * cos(D2) * cos(H2) - Z;
_0x1A:
	CALL SUBOPT_0x49
	CALL SUBOPT_0x30
	CALL SUBOPT_0x45
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x49
	CALL SUBOPT_0x36
	CALL SUBOPT_0x46
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_H2
	LDS  R31,_H2+1
	LDS  R22,_H2+2
	LDS  R23,_H2+3
	CALL SUBOPT_0x36
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x47
	STS  _V2,R30
	STS  _V2+1,R31
	STS  _V2+2,R22
	STS  _V2+3,R23
; 0000 00CD   if (Sgn(V0) == Sgn(V2)) {goto end2;}
	CALL SUBOPT_0x4A
	CALL __PUTPARD1
	RCALL _Sgn
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x4B
	CALL __PUTPARD1
	RCALL _Sgn
	POP  R26
	POP  R27
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x1B
	RJMP _0x1C
; 0000 00CE   V1 = S * sin(D1) + C * cos(D1) * cos(H1) - Z;
_0x1B:
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x30
	CALL SUBOPT_0x45
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x4C
	CALL SUBOPT_0x36
	CALL SUBOPT_0x46
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	LDS  R30,_H1
	LDS  R31,_H1+1
	LDS  R22,_H1+2
	LDS  R23,_H1+3
	CALL SUBOPT_0x36
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x47
	STS  _V1,R30
	STS  _V1+1,R31
	STS  _V1+2,R22
	STS  _V1+3,R23
; 0000 00CF   A = 2 * V2 - 4 * V1 + 2 * V0;
	CALL SUBOPT_0x4B
	CALL SUBOPT_0x20
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x4D
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x4A
	CALL SUBOPT_0x20
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __ADDF12
	CALL SUBOPT_0x1A
; 0000 00D0   B = 4 * V1 - 3 * V0 - V2;
	CALL SUBOPT_0x4D
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x4A
	__GETD2N 0x40400000
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x12
	CALL SUBOPT_0x4E
	CALL __SUBF12
	STS  _B,R30
	STS  _B+1,R31
	STS  _B+2,R22
	STS  _B+3,R23
; 0000 00D1   D = B * B - 4 * A * V0;
	CALL SUBOPT_0x4F
	LDS  R26,_B
	LDS  R27,_B+1
	LDS  R24,_B+2
	LDS  R25,_B+3
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x50
	__GETD2N 0x40800000
	CALL __MULF12
	CALL SUBOPT_0x51
	CALL __MULF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x12
	CALL SUBOPT_0x52
; 0000 00D2   if (D < 0) {goto end2;};
	LDS  R26,_D+3
	TST  R26
	BRPL _0x1D
	RJMP _0x1C
_0x1D:
; 0000 00D3   D = sqrt(D);
	CALL SUBOPT_0xE
	CALL SUBOPT_0x3E
	CALL SUBOPT_0x52
; 0000 00D4   E = (-B + D) / (2 * A);
	CALL SUBOPT_0x53
	CALL __ADDF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x50
	CALL SUBOPT_0x20
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x54
; 0000 00D5   if ((E > 1) || (E < 0)) {E = (-B - D) / (2 * A);}
	LDS  R26,_E
	LDS  R27,_E+1
	LDS  R24,_E+2
	LDS  R25,_E+3
	CALL SUBOPT_0xB
	CALL __CMPF12
	BREQ PC+4
	BRCS PC+3
	JMP  _0x1F
	LDS  R26,_E+3
	TST  R26
	BRPL _0x1E
_0x1F:
	CALL SUBOPT_0x53
	CALL __SUBF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x50
	CALL SUBOPT_0x20
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x54
; 0000 00D6   T3 = Hour + E + 1 / 120; // 
_0x1E:
	LDS  R30,_E
	LDS  R31,_E+1
	LDS  R22,_E+2
	LDS  R23,_E+3
	CALL SUBOPT_0x41
	CALL __ADDF12
	__GETD2N 0x0
	CALL __ADDF12
	STS  _T3,R30
	STS  _T3+1,R31
	STS  _T3+2,R22
	STS  _T3+3,R23
; 0000 00D7   H3 = Trunc(T3);
	CALL SUBOPT_0xF
	STS  _H3,R30
	STS  _H3+1,R31
	STS  _H3+2,R22
	STS  _H3+3,R23
; 0000 00D8   M3 = Trunc((T3 - H3) * 60);
	CALL SUBOPT_0x55
	LDS  R26,_T3
	LDS  R27,_T3+1
	LDS  R24,_T3+2
	LDS  R25,_T3+3
	CALL SUBOPT_0x28
	__GETD2N 0x42700000
	CALL __MULF12
	CALL SUBOPT_0xF
	STS  _M3,R30
	STS  _M3+1,R31
	STS  _M3+2,R22
	STS  _M3+3,R23
; 0000 00D9   if ((V0 < 0) && (V2 > 0)) {HH[0]=H3; MM[0]=M3; M8 = 1; st=1;};
	LDS  R26,_V0+3
	TST  R26
	BRPL _0x22
	CALL SUBOPT_0x4E
	CALL __CPD02
	BRLT _0x23
_0x22:
	RJMP _0x21
_0x23:
	CALL SUBOPT_0x55
	STS  _HH,R30
	STS  _HH+1,R31
	STS  _HH+2,R22
	STS  _HH+3,R23
	CALL SUBOPT_0x56
	STS  _MM,R30
	STS  _MM+1,R31
	STS  _MM+2,R22
	STS  _MM+3,R23
	CALL SUBOPT_0xB
	STS  _M8,R30
	STS  _M8+1,R31
	STS  _M8+2,R22
	STS  _M8+3,R23
	SET
	BLD  R2,0
_0x21:
; 0000 00DA   if ((V0 > 0) && (V2 < 0)) {HH[1]=H3; MM[1]=M3; W8 = 1; st=1;};
	CALL SUBOPT_0x51
	CALL __CPD02
	BRGE _0x25
	LDS  R26,_V2+3
	TST  R26
	BRMI _0x26
_0x25:
	RJMP _0x24
_0x26:
	CALL SUBOPT_0x55
	__PUTD1MN _HH,4
	CALL SUBOPT_0x56
	__PUTD1MN _MM,4
	CALL SUBOPT_0xB
	STS  _W8,R30
	STS  _W8+1,R31
	STS  _W8+2,R22
	STS  _W8+3,R23
	SET
	BLD  R2,0
_0x24:
; 0000 00DB end2:
_0x1C:
; 0000 00DC }
	ADIW R28,2
	RET
;
;
;void OutInform(void)
; 0000 00E0 {
_OutInform:
; 0000 00E1  if ((M8 == 0) && (W8 == 0))
	LDS  R26,_M8
	LDS  R27,_M8+1
	LDS  R24,_M8+2
	LDS  R25,_M8+3
	CALL __CPD02
	BRNE _0x28
	LDS  R26,_W8
	LDS  R27,_W8+1
	LDS  R24,_W8+2
	LDS  R25,_W8+3
	CALL __CPD02
	BREQ _0x29
_0x28:
	RJMP _0x27
_0x29:
; 0000 00E2  {
; 0000 00E3     if (V2 < 0) {st=0; cld_cls();}
	LDS  R26,_V2+3
	TST  R26
	BRPL _0x2A
	CALL SUBOPT_0x57
; 0000 00E4 //      ListBox.Items.Add('    ');
; 0000 00E5     if (V2 > 0) {st=0; cld_cls();}
_0x2A:
	CALL SUBOPT_0x4E
	CALL __CPD02
	BRGE _0x2B
	CALL SUBOPT_0x57
; 0000 00E6 //      ListBox.Items.Add('    ');
; 0000 00E7  }
_0x2B:
; 0000 00E8   else
	RJMP _0x2C
_0x27:
; 0000 00E9   {
; 0000 00EA     if (M8 == 0) {st=0; cld_cls();}
	LDS  R30,_M8
	LDS  R31,_M8+1
	LDS  R22,_M8+2
	LDS  R23,_M8+3
	CALL __CPD10
	BRNE _0x2D
	CALL SUBOPT_0x57
; 0000 00EB //      ListBox.Items.Add('      ');
; 0000 00EC     if (W8 == 0) {st=0; cld_cls();}
_0x2D:
	LDS  R30,_W8
	LDS  R31,_W8+1
	LDS  R22,_W8+2
	LDS  R23,_W8+3
	CALL __CPD10
	BRNE _0x2E
	CALL SUBOPT_0x57
; 0000 00ED //      ListBox.Items.Add('      ');
; 0000 00EE   }
_0x2E:
_0x2C:
; 0000 00EF }
	RET
;
;void show_info(void)
; 0000 00F2 {
_show_info:
; 0000 00F3   D = day;
	LDS  R30,_day
	LDS  R31,_day+1
	LDI  R26,LOW(_D)
	LDI  R27,HIGH(_D)
	CALL SUBOPT_0x19
; 0000 00F4   L5=lat;
	CALL SUBOPT_0x58
	CALL SUBOPT_0x59
; 0000 00F5   L5 = L5 / 360;
	LDS  R26,_L5
	LDS  R27,_L5+1
	LDS  R24,_L5+2
	LDS  R25,_L5+3
	__GETD1N 0x43B40000
	CALL __DIVF21
	CALL SUBOPT_0x59
; 0000 00F6   Z0 = (float) H / 24;
	CALL SUBOPT_0x5A
	CALL SUBOPT_0x5B
	STS  _Z0,R30
	STS  _Z0+1,R31
	STS  _Z0+2,R22
	STS  _Z0+3,R23
; 0000 00F7   Calendar();
	RCALL _Calendar
; 0000 00F8   T = (J - 2451545) + F;
	CALL SUBOPT_0x1D
	__GETD1N 0x4A15A164
	CALL SUBOPT_0x12
	LDS  R26,_F
	LDS  R27,_F+1
	LDS  R24,_F+2
	LDS  R25,_F+3
	CALL SUBOPT_0x5C
; 0000 00F9   TT = T / 36525 + 1; // TT - ,   1900.0
	CALL SUBOPT_0x23
	CALL SUBOPT_0x5D
	STS  _TT,R30
	STS  _TT+1,R31
	STS  _TT+2,R22
	STS  _TT+3,R23
; 0000 00FA   GetTimeZone(); //   
	RCALL _GetTimeZone
; 0000 00FB   T = T + Z0;
	CALL SUBOPT_0x26
	LDS  R26,_T
	LDS  R27,_T+1
	LDS  R24,_T+2
	LDS  R25,_T+3
	CALL SUBOPT_0x5C
; 0000 00FC   PosOfSun(); //   
	CALL SUBOPT_0x5E
; 0000 00FD   aA[0] = A5;
	STS  _aA,R30
	STS  _aA+1,R31
	STS  _aA+2,R22
	STS  _aA+3,R23
; 0000 00FE   aD[0] = D5;
	CALL SUBOPT_0x5F
	STS  _aD,R30
	STS  _aD+1,R31
	STS  _aD+2,R22
	STS  _aD+3,R23
; 0000 00FF   T = T + 1;
	CALL SUBOPT_0x2B
	CALL SUBOPT_0x21
	CALL SUBOPT_0x5C
; 0000 0100   PosOfSun();
	CALL SUBOPT_0x5E
; 0000 0101   aA[1] = A5;
	CALL SUBOPT_0x60
; 0000 0102   aD[1] = D5;
	CALL SUBOPT_0x5F
	__PUTD1MN _aD,4
; 0000 0103   if (aA[1] < aA[0]) {aA[1] = aA[1] + P2;}
	CALL SUBOPT_0x61
	CALL SUBOPT_0x62
	CALL __CMPF12
	BRSH _0x2F
	CALL SUBOPT_0x2F
	CALL SUBOPT_0x61
	CALL __ADDF12
	CALL SUBOPT_0x60
; 0000 0104   Z1 = DR * 90.833; //  
_0x2F:
	CALL SUBOPT_0x2A
	__GETD2N 0x42B5AA7F
	CALL __MULF12
	STS  _Z1,R30
	STS  _Z1+1,R31
	STS  _Z1+2,R22
	STS  _Z1+3,R23
; 0000 0105   S = sin(B5 * DR);
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x63
	CALL SUBOPT_0x30
	CALL SUBOPT_0x29
; 0000 0106   C = cos(B5 * DR);
	CALL SUBOPT_0x2A
	CALL SUBOPT_0x63
	CALL SUBOPT_0x36
	STS  _C,R30
	STS  _C+1,R31
	STS  _C+2,R22
	STS  _C+3,R23
; 0000 0107   Z = cos(Z1);
	LDS  R30,_Z1
	LDS  R31,_Z1+1
	LDS  R22,_Z1+2
	LDS  R23,_Z1+3
	CALL SUBOPT_0x36
	STS  _Z,R30
	STS  _Z+1,R31
	STS  _Z+2,R22
	STS  _Z+3,R23
; 0000 0108   M8 = 0;
	LDI  R30,LOW(0)
	STS  _M8,R30
	STS  _M8+1,R30
	STS  _M8+2,R30
	STS  _M8+3,R30
; 0000 0109   W8 = 0;
	STS  _W8,R30
	STS  _W8+1,R30
	STS  _W8+2,R30
	STS  _W8+3,R30
; 0000 010A   A0 = aA[0];
	CALL SUBOPT_0x62
	CALL SUBOPT_0x64
; 0000 010B   D0 = aD[0];
	LDS  R30,_aD
	LDS  R31,_aD+1
	LDS  R22,_aD+2
	LDS  R23,_aD+3
	CALL SUBOPT_0x65
; 0000 010C   DA = aA[1] - aA[0];
	__GETD1MN _aA,4
	CALL SUBOPT_0x66
	CALL __SUBF12
	STS  _DA,R30
	STS  _DA+1,R31
	STS  _DA+2,R22
	STS  _DA+3,R23
; 0000 010D   DD = aD[1] - aD[0];
	__GETD1MN _aD,4
	CALL SUBOPT_0x67
	CALL __SUBF12
	STS  _DD,R30
	STS  _DD+1,R31
	STS  _DD+2,R22
	STS  _DD+3,R23
; 0000 010E   for (C0 = 0; C0 < 24; C0++)
	LDI  R30,LOW(0)
	STS  _C0,R30
	STS  _C0+1,R30
	STS  _C0+2,R30
	STS  _C0+3,R30
_0x31:
	LDS  R26,_C0
	LDS  R27,_C0+1
	LDS  R24,_C0+2
	LDS  R25,_C0+3
	__CPD2N 0x18
	BRLT PC+3
	JMP _0x32
; 0000 010F   {
; 0000 0110     P = ((float)C0 + 1) / 24;
	LDS  R30,_C0
	LDS  R31,_C0+1
	LDS  R22,_C0+2
	LDS  R23,_C0+3
	CALL __CDF1
	CALL SUBOPT_0x5D
	CALL SUBOPT_0x5B
	STS  _P,R30
	STS  _P+1,R31
	STS  _P+2,R22
	STS  _P+3,R23
; 0000 0111     A2 = aA[0] + P * DA;
	LDS  R30,_DA
	LDS  R31,_DA+1
	LDS  R22,_DA+2
	LDS  R23,_DA+3
	CALL SUBOPT_0x68
	CALL SUBOPT_0x66
	CALL __ADDF12
	STS  _A2,R30
	STS  _A2+1,R31
	STS  _A2+2,R22
	STS  _A2+3,R23
; 0000 0112     D2 = aD[0] + P * DD;
	LDS  R30,_DD
	LDS  R31,_DD+1
	LDS  R22,_DD+2
	LDS  R23,_DD+3
	CALL SUBOPT_0x68
	CALL SUBOPT_0x67
	CALL __ADDF12
	STS  _D2,R30
	STS  _D2+1,R31
	STS  _D2+2,R22
	STS  _D2+3,R23
; 0000 0113     PossibleEvents(C0);
	LDS  R30,_C0
	LDS  R31,_C0+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _PossibleEvents
; 0000 0114     if (st != 0) {sun_info();}
	SBRC R2,0
	RCALL _sun_info
; 0000 0115     A0 = A2;
	LDS  R30,_A2
	LDS  R31,_A2+1
	LDS  R22,_A2+2
	LDS  R23,_A2+3
	CALL SUBOPT_0x64
; 0000 0116     D0 = D2;
	CALL SUBOPT_0x49
	CALL SUBOPT_0x65
; 0000 0117     V0 = V2;
	CALL SUBOPT_0x4B
	CALL SUBOPT_0x48
; 0000 0118   }
	LDI  R26,LOW(_C0)
	LDI  R27,HIGH(_C0)
	CALL SUBOPT_0x69
	RJMP _0x31
_0x32:
; 0000 0119   OutInform();
	RCALL _OutInform
; 0000 011A }
	RET
;
;void display(void)
; 0000 011D { unsigned int i;
_display:
; 0000 011E   lcd_gotoxy(13,0);
	ST   -Y,R17
	ST   -Y,R16
;	i -> R16,R17
	LDI  R30,LOW(13)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _lcd_gotoxy
; 0000 011F   lcd_putsf("Z");
	__POINTW1FN _0x0,16
	CALL SUBOPT_0x3
; 0000 0120   i=Trunc(Abs(H));
	CALL SUBOPT_0x5A
	CALL SUBOPT_0x6A
	CALL SUBOPT_0xF
	MOVW R16,R30
; 0000 0121   lcd_putchar (i/10%10+0x30);
	CALL SUBOPT_0x6B
; 0000 0122   lcd_putchar (i%10+0x30);
; 0000 0123   lcd_gotoxy(0,1);
	CALL SUBOPT_0x6C
; 0000 0124   lcd_putchar (hr/10%10+0x30);
	__GETW2R 7,8
	CALL SUBOPT_0x6D
; 0000 0125   lcd_putchar (hr%10+0x30);
	__GETW2R 7,8
	CALL SUBOPT_0x6E
; 0000 0126   lcd_putchar (delim);
	LDS  R30,_delim
	ST   -Y,R30
	CALL _lcd_putchar
; 0000 0127   lcd_putchar (mins/10%10+0x30);
	__GETW2R 9,10
	CALL SUBOPT_0x6D
; 0000 0128   lcd_putchar (mins%10+0x30);
	__GETW2R 9,10
	CALL SUBOPT_0x6E
; 0000 0129   lcd_putsf (" ");
	__POINTW1FN _0x0,14
	CALL SUBOPT_0x3
; 0000 012A   lcd_putchar ((day/10)%10+0x30);
	CALL SUBOPT_0x6F
	CALL SUBOPT_0x6D
; 0000 012B   lcd_putchar (day%10+0x30);
	CALL SUBOPT_0x6F
	CALL SUBOPT_0x6E
; 0000 012C   lcd_putsf ("/");
	__POINTW1FN _0x0,18
	CALL SUBOPT_0x3
; 0000 012D   lcd_putchar ((M/10)%10+0x30);
	CALL SUBOPT_0x70
	CALL SUBOPT_0x8
; 0000 012E   lcd_putchar (M%10+0x30);
	CALL SUBOPT_0x70
	CALL SUBOPT_0x9
; 0000 012F   lcd_putsf ("/");
	__POINTW1FN _0x0,18
	CALL SUBOPT_0x3
; 0000 0130   lcd_putchar ((Y/1000)%10+0x30);
	CALL SUBOPT_0xD
	__GETD1N 0x3E8
	CALL SUBOPT_0x8
; 0000 0131   lcd_putchar ((Y/100)%10+0x30);
	CALL SUBOPT_0xD
	__GETD1N 0x64
	CALL SUBOPT_0x8
; 0000 0132   lcd_putchar ((Y/10)%10+0x30);
	CALL SUBOPT_0x71
	CALL SUBOPT_0x8
; 0000 0133   lcd_putchar (Y%10+0x30);
	CALL SUBOPT_0x71
	CALL SUBOPT_0x9
; 0000 0134 }
	LD   R16,Y+
	LD   R17,Y+
	RET
;
;/*unsigned int enter_data(char *inf, unsigned int nmin, unsigned int nmax, unsigned int param)
;{
;  lcd_gotoxy(0,1);
;  lcd_puts(inf);
;  while (key!=Ok)
;  {
;    display();
;    if ((key==Up) & (param<nmax)) {delay_ms(50); param++;}
;    if ((key==Down) & (param>nmin)) {delay_ms(50); param--;}
;  }
;  return param;
;}*/
;
;void clock(void)
; 0000 0144 { unsigned char qty_days;
_clock:
; 0000 0145   if (msec>=150)
	ST   -Y,R17
;	qty_days -> R17
	LDI  R30,LOW(150)
	LDI  R31,HIGH(150)
	CP   R13,R30
	CPC  R14,R31
	BRLT _0x34
; 0000 0146   {
; 0000 0147     msec=0; sec++;
	CLR  R13
	CLR  R14
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__ADDWRR 11,12,30,31
; 0000 0148     if (delim==':') {delim=' ';}
	LDS  R26,_delim
	CPI  R26,LOW(0x3A)
	BRNE _0x35
	LDI  R30,LOW(32)
	RJMP _0x7B
; 0000 0149     else {delim=':';};
_0x35:
	LDI  R30,LOW(58)
_0x7B:
	STS  _delim,R30
; 0000 014A   };
_0x34:
; 0000 014B   if (sec==60) {sec=0; mins++;};
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CP   R30,R11
	CPC  R31,R12
	BRNE _0x37
	CLR  R11
	CLR  R12
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__ADDWRR 9,10,30,31
_0x37:
; 0000 014C   if (mins==60) {mins=0; hr++;};
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CP   R30,R9
	CPC  R31,R10
	BRNE _0x38
	CLR  R9
	CLR  R10
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__ADDWRR 7,8,30,31
_0x38:
; 0000 014D   if (hr==24) {day++; hr=0; show_info();};
	LDI  R30,LOW(24)
	LDI  R31,HIGH(24)
	CP   R30,R7
	CPC  R31,R8
	BRNE _0x39
	LDI  R26,LOW(_day)
	LDI  R27,HIGH(_day)
	CALL SUBOPT_0x0
	CLR  R7
	CLR  R8
	RCALL _show_info
_0x39:
; 0000 014E   qty_days=days_month[M-1];
	CALL SUBOPT_0x14
	__SUBD1N 1
	SUBI R30,LOW(-_days_month)
	SBCI R31,HIGH(-_days_month)
	MOVW R26,R30
	CALL __EEPROMRDB
	MOV  R17,R30
; 0000 014F   if ((M==2) && (Y%4)==(Y/4)) {qty_days=29;}
	CALL SUBOPT_0x72
	__CPD2N 0x2
	BRNE _0x3B
	CALL SUBOPT_0x73
	CALL __MODD21
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x73
	CALL __DIVD21
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __CPD12
	BREQ _0x3C
_0x3B:
	RJMP _0x3A
_0x3C:
	LDI  R17,LOW(29)
; 0000 0150   if (day==qty_days) {M++; day=1;};
_0x3A:
	MOV  R30,R17
	CALL SUBOPT_0x6F
	LDI  R31,0
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x3D
	LDI  R26,LOW(_M)
	LDI  R27,HIGH(_M)
	CALL SUBOPT_0x69
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _day,R30
	STS  _day+1,R31
_0x3D:
; 0000 0151   if (M==12) {M=1; Y++;};
	CALL SUBOPT_0x72
	__CPD2N 0xC
	BRNE _0x3E
	__GETD1N 0x1
	STS  _M,R30
	STS  _M+1,R31
	STS  _M+2,R22
	STS  _M+3,R23
	LDI  R26,LOW(_Y)
	LDI  R27,HIGH(_Y)
	CALL SUBOPT_0x69
_0x3E:
; 0000 0152   display();
	RCALL _display
; 0000 0153   if ((HH[0]!=HH[1]) && (MM[0]!=MM[1]))
	CALL SUBOPT_0x74
	CALL SUBOPT_0x75
	CALL __CPD12
	BREQ _0x40
	CALL SUBOPT_0x76
	CALL SUBOPT_0x77
	CALL __CPD12
	BRNE _0x41
_0x40:
	RJMP _0x3F
_0x41:
; 0000 0154   {
; 0000 0155     if ((hr*60+mins)>(HH[0]*60+MM[0])) {st=1;};
	CALL SUBOPT_0x78
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x75
	__GETD1N 0x3C
	CALL __MULD12
	CALL SUBOPT_0x77
	CALL __ADDD12
	POP  R26
	POP  R27
	CALL __CWD2
	CALL __CPD12
	BRGE _0x42
	SET
	BLD  R2,0
_0x42:
; 0000 0156     if ((hr*60+mins)>(HH[1]*60+MM[1])) {st=0;};
	CALL SUBOPT_0x78
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x74
	__GETD2N 0x3C
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	CALL SUBOPT_0x76
	CALL __ADDD12
	POP  R26
	POP  R27
	CALL __CWD2
	CALL __CPD12
	BRGE _0x43
	CLT
	BLD  R2,0
_0x43:
; 0000 0157   }
; 0000 0158   if (st==0) {light_on;} else
_0x3F:
	SBRC R2,0
	RJMP _0x44
	SBI  0x15,0
	RJMP _0x47
_0x44:
; 0000 0159   if (st==1) {light_off;}
	SBRC R2,0
	CBI  0x15,0
; 0000 015A  }
_0x47:
	LD   R17,Y+
	RET
;
;
;void main(void)
; 0000 015E {
_main:
; 0000 015F unsigned int tmp;
; 0000 0160 
; 0000 0161 // Declare your local variables here
; 0000 0162 
; 0000 0163 // Input/Output Ports initialization
; 0000 0164 // Port A initialization
; 0000 0165 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=Out Func1=Out Func0=Out
; 0000 0166 // State7=0 State6=0 State5=0 State4=0 State3=T State2=0 State1=0 State0=0
; 0000 0167 PORTA=0x00;
;	tmp -> R16,R17
	LDI  R30,LOW(0)
	OUT  0x1B,R30
; 0000 0168 DDRA=0xF7;
	LDI  R30,LOW(247)
	OUT  0x1A,R30
; 0000 0169 
; 0000 016A // Port B initialization
; 0000 016B // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 016C // State7=T State6=T State5=T State4=P State3=P State2=P State1=P State0=P
; 0000 016D PORTB=0x1F;
	LDI  R30,LOW(31)
	OUT  0x18,R30
; 0000 016E DDRB=0x00;
	LDI  R30,LOW(0)
	OUT  0x17,R30
; 0000 016F 
; 0000 0170 // Port C initialization
; 0000 0171 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=Out
; 0000 0172 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=0
; 0000 0173 PORTC=0x00;
	OUT  0x15,R30
; 0000 0174 DDRC=0x01;
	LDI  R30,LOW(1)
	OUT  0x14,R30
; 0000 0175 
; 0000 0176 // Port D initialization
; 0000 0177 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
; 0000 0178 // State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T
; 0000 0179 PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0x12,R30
; 0000 017A DDRD=0x00;
	OUT  0x11,R30
; 0000 017B 
; 0000 017C // Timer/Counter 0 initialization
; 0000 017D // Clock source: System Clock
; 0000 017E // Clock value: 500,000 kHz
; 0000 017F // Mode: Normal top=FFh
; 0000 0180 // OC0 output: Disconnected
; 0000 0181 TCCR0=0x02;
	LDI  R30,LOW(2)
	OUT  0x33,R30
; 0000 0182 TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
; 0000 0183 OCR0=0x00;
	OUT  0x3C,R30
; 0000 0184 
; 0000 0185 // Timer/Counter 1 initialization
; 0000 0186 // Clock source: System Clock
; 0000 0187 // Clock value: Timer 1 Stopped
; 0000 0188 // Mode: Normal top=FFFFh
; 0000 0189 // OC1A output: Discon.
; 0000 018A // OC1B output: Discon.
; 0000 018B // Noise Canceler: Off
; 0000 018C // Input Capture on Falling Edge
; 0000 018D // Timer 1 Overflow Interrupt: Off
; 0000 018E // Input Capture Interrupt: Off
; 0000 018F // Compare A Match Interrupt: Off
; 0000 0190 // Compare B Match Interrupt: Off
; 0000 0191 TCCR1A=0x00;
	OUT  0x2F,R30
; 0000 0192 TCCR1B=0x00;
	OUT  0x2E,R30
; 0000 0193 TCNT1H=0x00;
	OUT  0x2D,R30
; 0000 0194 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 0195 ICR1H=0x00;
	OUT  0x27,R30
; 0000 0196 ICR1L=0x00;
	OUT  0x26,R30
; 0000 0197 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 0198 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 0199 OCR1BH=0x00;
	OUT  0x29,R30
; 0000 019A OCR1BL=0x00;
	OUT  0x28,R30
; 0000 019B 
; 0000 019C // Timer/Counter 2 initialization
; 0000 019D // Clock source: System Clock
; 0000 019E // Clock value: 3,906 kHz
; 0000 019F // Mode: Normal top=FFh
; 0000 01A0 // OC2 output: Disconnected
; 0000 01A1 ASSR=0x00;
	OUT  0x22,R30
; 0000 01A2 TCCR2=0x07;
	LDI  R30,LOW(7)
	OUT  0x25,R30
; 0000 01A3 TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 01A4 OCR2=0x00;
	OUT  0x23,R30
; 0000 01A5 
; 0000 01A6 // External Interrupt(s) initialization
; 0000 01A7 // INT0: Off
; 0000 01A8 // INT1: Off
; 0000 01A9 // INT2: Off
; 0000 01AA MCUCR=0x00;
	OUT  0x35,R30
; 0000 01AB MCUCSR=0x00;
	OUT  0x34,R30
; 0000 01AC 
; 0000 01AD // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 01AE TIMSK=0x41;
	LDI  R30,LOW(65)
	OUT  0x39,R30
; 0000 01AF 
; 0000 01B0 // Analog Comparator initialization
; 0000 01B1 // Analog Comparator: Off
; 0000 01B2 // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 01B3 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 01B4 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 01B5 
; 0000 01B6 // LCD module initialization
; 0000 01B7 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _lcd_init
; 0000 01B8 // Global enable interrupts
; 0000 01B9 #asm("sei")
	sei
; 0000 01BA 
; 0000 01BB //  M=enter_data("Enter month <-->", 1, 12, M)
; 0000 01BC 
; 0000 01BD lcd_gotoxy(0,0);
	CALL SUBOPT_0x2
; 0000 01BE lcd_putsf(" = Auto Light = ");
	__POINTW1FN _0x0,20
	CALL SUBOPT_0x3
; 0000 01BF lcd_gotoxy(0,1);
	CALL SUBOPT_0x6C
; 0000 01C0 lcd_putsf("    ver. 1.0    ");
	__POINTW1FN _0x0,37
	CALL SUBOPT_0x3
; 0000 01C1 while (key!=Ok){}
_0x4B:
	CP   R4,R5
	BRNE _0x4B
; 0000 01C2 me_delay();
	CALL SUBOPT_0x79
; 0000 01C3 
; 0000 01C4 lcd_gotoxy(0,0);
; 0000 01C5 lcd_putsf("Enter latitude ");
	__POINTW1FN _0x0,54
	CALL SUBOPT_0x3
; 0000 01C6 lcd_gotoxy(0,1);
	CALL SUBOPT_0x6C
; 0000 01C7 lcd_putsf("                ");
	__POINTW1FN _0x0,70
	CALL SUBOPT_0x3
; 0000 01C8 while (key!=Ok)
_0x4E:
	CP   R4,R5
	BREQ _0x50
; 0000 01C9 {
; 0000 01CA   lcd_gotoxy(6,1);
	CALL SUBOPT_0x7A
; 0000 01CB   lcd_putchar (B5/10%10+0x30);
	CALL SUBOPT_0x7B
	CALL SUBOPT_0x8
; 0000 01CC   lcd_putchar (B5%10+0x30);
	CALL SUBOPT_0x7B
	CALL SUBOPT_0x9
; 0000 01CD   if ((key==Up) & (B5<90)) {B5++; delay_ms(200);}
	CALL SUBOPT_0x7C
	CALL SUBOPT_0x7D
	__GETD1N 0x5A
	CALL __LTD12
	AND  R30,R0
	BREQ _0x51
	LDI  R26,LOW(_B5)
	LDI  R27,HIGH(_B5)
	CALL SUBOPT_0x69
	CALL SUBOPT_0x1
; 0000 01CE   if ((key==Down) & (B5>0)) {B5--; delay_ms(200);}
_0x51:
	CALL SUBOPT_0x7E
	CALL SUBOPT_0x7D
	__GETD1N 0x0
	CALL __GTD12
	AND  R30,R0
	BREQ _0x52
	LDI  R26,LOW(_B5)
	LDI  R27,HIGH(_B5)
	CALL SUBOPT_0x7F
; 0000 01CF   // 0  ()   180   -  
; 0000 01D0 }
_0x52:
	RJMP _0x4E
_0x50:
; 0000 01D1 
; 0000 01D2 me_delay();
	CALL SUBOPT_0x79
; 0000 01D3 
; 0000 01D4 lcd_gotoxy(0,0);
; 0000 01D5 lcd_putsf("Enter longitude ");
	__POINTW1FN _0x0,87
	CALL SUBOPT_0x3
; 0000 01D6 lcd_gotoxy(0,1);
	CALL SUBOPT_0x6C
; 0000 01D7 lcd_putsf("                ");
	__POINTW1FN _0x0,70
	CALL SUBOPT_0x3
; 0000 01D8 tmp=(int)lat;
	CALL SUBOPT_0x58
	CALL __CFD1
	MOVW R16,R30
; 0000 01D9 while (key!=Ok)
_0x53:
	CP   R4,R5
	BREQ _0x55
; 0000 01DA {
; 0000 01DB   lcd_gotoxy(6,1);
	CALL SUBOPT_0x7A
; 0000 01DC   lcd_putchar (tmp/10%10+0x30);
	CALL SUBOPT_0x6B
; 0000 01DD   lcd_putchar (tmp%10+0x30);
; 0000 01DE   if ((key==Up) & (tmp<180)) {tmp++; delay_ms(200);}
	CALL SUBOPT_0x7C
	MOVW R26,R16
	LDI  R30,LOW(180)
	LDI  R31,HIGH(180)
	CALL __LTW12U
	AND  R30,R0
	BREQ _0x56
	__ADDWRN 16,17,1
	CALL SUBOPT_0x1
; 0000 01DF   if ((key==Down) & (tmp>0)) {tmp--; delay_ms(200);}
_0x56:
	CALL SUBOPT_0x7E
	MOVW R26,R16
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	CALL __GTW12U
	AND  R30,R0
	BREQ _0x57
	__SUBWRN 16,17,1
	CALL SUBOPT_0x1
; 0000 01E0   // 0  ()   180   -  
; 0000 01E1 }
_0x57:
	RJMP _0x53
_0x55:
; 0000 01E2 me_delay();
	CALL _me_delay
; 0000 01E3 lat=(float) tmp;
	MOVW R30,R16
	CLR  R22
	CLR  R23
	CALL __CDF1
	STS  _lat,R30
	STS  _lat+1,R31
	STS  _lat+2,R22
	STS  _lat+3,R23
; 0000 01E4 
; 0000 01E5 
; 0000 01E6 lcd_gotoxy(0,0);
	CALL SUBOPT_0x2
; 0000 01E7 lcd_putsf("Enter month  ");
	__POINTW1FN _0x0,104
	CALL SUBOPT_0x3
; 0000 01E8 
; 0000 01E9 while (key!=Ok)
_0x58:
	CP   R4,R5
	BREQ _0x5A
; 0000 01EA {
; 0000 01EB   display();
	CALL SUBOPT_0x80
; 0000 01EC   if ((key==Up) & (M<12)) {M++; delay_ms(200);}
	CALL SUBOPT_0x72
	__GETD1N 0xC
	CALL __LTD12
	AND  R30,R0
	BREQ _0x5B
	LDI  R26,LOW(_M)
	LDI  R27,HIGH(_M)
	CALL SUBOPT_0x69
	CALL SUBOPT_0x1
; 0000 01ED   if ((key==Down) & (M>1)) {M--; delay_ms(200);}
_0x5B:
	CALL SUBOPT_0x7E
	CALL SUBOPT_0x72
	__GETD1N 0x1
	CALL __GTD12
	AND  R30,R0
	BREQ _0x5C
	LDI  R26,LOW(_M)
	LDI  R27,HIGH(_M)
	CALL SUBOPT_0x7F
; 0000 01EE }
_0x5C:
	RJMP _0x58
_0x5A:
; 0000 01EF me_delay();
	CALL SUBOPT_0x79
; 0000 01F0 
; 0000 01F1 lcd_gotoxy(0,0);
; 0000 01F2 lcd_putsf("Enter day    ");
	__POINTW1FN _0x0,118
	CALL SUBOPT_0x3
; 0000 01F3 
; 0000 01F4 while (key!=Ok)
_0x5D:
	CP   R4,R5
	BREQ _0x5F
; 0000 01F5 {
; 0000 01F6   display();
	CALL SUBOPT_0x80
; 0000 01F7   if ((key==Up) & (day<days_month[M])) {day++; delay_ms(200);}
	CALL SUBOPT_0x14
	SUBI R30,LOW(-_days_month)
	SBCI R31,HIGH(-_days_month)
	MOVW R26,R30
	CALL __EEPROMRDB
	CALL SUBOPT_0x6F
	LDI  R31,0
	CALL __LTW12
	AND  R30,R0
	BREQ _0x60
	LDI  R26,LOW(_day)
	LDI  R27,HIGH(_day)
	CALL SUBOPT_0x0
	CALL SUBOPT_0x1
; 0000 01F8   if ((key==Down) & (day>1)) {day--; delay_ms(200);}
_0x60:
	CALL SUBOPT_0x7E
	CALL SUBOPT_0x6F
	CALL SUBOPT_0x81
	BREQ _0x61
	LDI  R26,LOW(_day)
	LDI  R27,HIGH(_day)
	LD   R30,X+
	LD   R31,X+
	SBIW R30,1
	ST   -X,R31
	ST   -X,R30
	CALL SUBOPT_0x1
; 0000 01F9 }
_0x61:
	RJMP _0x5D
_0x5F:
; 0000 01FA me_delay();
	CALL SUBOPT_0x79
; 0000 01FB 
; 0000 01FC lcd_gotoxy(0,0);
; 0000 01FD lcd_putsf("Enter year   ");
	__POINTW1FN _0x0,132
	CALL SUBOPT_0x3
; 0000 01FE 
; 0000 01FF while (key!=Ok)
_0x62:
	CP   R4,R5
	BREQ _0x64
; 0000 0200 {
; 0000 0201   display();
	CALL SUBOPT_0x80
; 0000 0202   if ((key==Up) & (Y<2100)) {Y++; delay_ms(200);}
	CALL SUBOPT_0xD
	__GETD1N 0x834
	CALL __LTD12
	AND  R30,R0
	BREQ _0x65
	LDI  R26,LOW(_Y)
	LDI  R27,HIGH(_Y)
	CALL SUBOPT_0x69
	CALL SUBOPT_0x1
; 0000 0203   if ((key==Down) & (Y>1900)) {Y--; delay_ms(200);}
_0x65:
	CALL SUBOPT_0x7E
	CALL SUBOPT_0xD
	__GETD1N 0x76C
	CALL __GTD12
	AND  R30,R0
	BREQ _0x66
	LDI  R26,LOW(_Y)
	LDI  R27,HIGH(_Y)
	CALL SUBOPT_0x7F
; 0000 0204 }
_0x66:
	RJMP _0x62
_0x64:
; 0000 0205 me_delay();
	CALL SUBOPT_0x79
; 0000 0206 
; 0000 0207 lcd_gotoxy(0,0);
; 0000 0208 lcd_putsf("Enter hours  ");
	__POINTW1FN _0x0,146
	CALL SUBOPT_0x3
; 0000 0209 
; 0000 020A while (key!=Ok)
_0x67:
	CP   R4,R5
	BREQ _0x69
; 0000 020B {
; 0000 020C   display();
	CALL SUBOPT_0x80
; 0000 020D   if ((key==Up) & (hr<24)) {hr++; delay_ms(200);}
	__GETW2R 7,8
	LDI  R30,LOW(24)
	LDI  R31,HIGH(24)
	CALL __LTW12
	AND  R30,R0
	BREQ _0x6A
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__ADDWRR 7,8,30,31
	CALL SUBOPT_0x1
; 0000 020E   if ((key==Down) & (hr>1)) {hr--; delay_ms(200);}
_0x6A:
	CALL SUBOPT_0x7E
	__GETW2R 7,8
	CALL SUBOPT_0x81
	BREQ _0x6B
	__GETW1R 7,8
	SBIW R30,1
	__PUTW1R 7,8
	CALL SUBOPT_0x1
; 0000 020F }
_0x6B:
	RJMP _0x67
_0x69:
; 0000 0210 me_delay();
	CALL SUBOPT_0x79
; 0000 0211 
; 0000 0212 lcd_gotoxy(0,0);
; 0000 0213 lcd_putsf("Enter minits ");
	__POINTW1FN _0x0,160
	CALL SUBOPT_0x3
; 0000 0214 
; 0000 0215 while (key!=Ok)
_0x6C:
	CP   R4,R5
	BREQ _0x6E
; 0000 0216 {
; 0000 0217   display();
	CALL SUBOPT_0x80
; 0000 0218   if ((key==Up) & (mins<59)) {mins++; delay_ms(200);}
	__GETW2R 9,10
	LDI  R30,LOW(59)
	LDI  R31,HIGH(59)
	CALL __LTW12
	AND  R30,R0
	BREQ _0x6F
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__ADDWRR 9,10,30,31
	CALL SUBOPT_0x1
; 0000 0219   if ((key==Down) & (mins>1)) {mins--; delay_ms(200);}
_0x6F:
	CALL SUBOPT_0x7E
	__GETW2R 9,10
	CALL SUBOPT_0x81
	BREQ _0x70
	__GETW1R 9,10
	SBIW R30,1
	__PUTW1R 9,10
	CALL SUBOPT_0x1
; 0000 021A }
_0x70:
	RJMP _0x6C
_0x6E:
; 0000 021B me_delay();
	CALL SUBOPT_0x79
; 0000 021C 
; 0000 021D lcd_gotoxy(0,0);
; 0000 021E lcd_putsf("Enter zone  ");
	__POINTW1FN _0x0,174
	CALL SUBOPT_0x3
; 0000 021F 
; 0000 0220 while (key!=Ok)
_0x71:
	CP   R4,R5
	BREQ _0x73
; 0000 0221 {
; 0000 0222   display();
	RCALL _display
; 0000 0223   if ((key==Up) & (Abs(H)<12)) {H--; delay_ms(200);}
	MOV  R30,R6
	MOV  R26,R5
	CALL __EQB12
	PUSH R30
	CALL SUBOPT_0x5A
	CALL SUBOPT_0x6A
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x41400000
	CALL __LTF12
	POP  R26
	AND  R30,R26
	BREQ _0x74
	LDI  R26,LOW(_H)
	LDI  R27,HIGH(_H)
	CALL SUBOPT_0x7F
; 0000 0224   if ((key==Down) & (Abs(H)>0)) {H++; delay_ms(200);}
_0x74:
	MOV  R30,R3
	MOV  R26,R5
	CALL __EQB12
	PUSH R30
	CALL SUBOPT_0x5A
	CALL SUBOPT_0x6A
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x0
	CALL __GTF12
	POP  R26
	AND  R30,R26
	BREQ _0x75
	LDI  R26,LOW(_H)
	LDI  R27,HIGH(_H)
	CALL SUBOPT_0x69
	CALL SUBOPT_0x1
; 0000 0225   // 0  ()   180   -  
; 0000 0226 }
_0x75:
	RJMP _0x71
_0x73:
; 0000 0227 
; 0000 0228 
; 0000 0229 clock();
	RCALL _clock
; 0000 022A show_info();
	RCALL _show_info
; 0000 022B 
; 0000 022C while (1)
_0x76:
; 0000 022D       {
; 0000 022E       // Place your code here
; 0000 022F           clock();
	RCALL _clock
; 0000 0230       };
	RJMP _0x76
; 0000 0231 }
_0x79:
	RJMP _0x79

	.CSEG
_ftrunc:
   ldd  r23,y+3
   ldd  r22,y+2
   ldd  r31,y+1
   ld   r30,y
   bst  r23,7
   lsl  r23
   sbrc r22,7
   sbr  r23,1
   mov  r25,r23
   subi r25,0x7e
   breq __ftrunc0
   brcs __ftrunc0
   cpi  r25,24
   brsh __ftrunc1
   clr  r26
   clr  r27
   clr  r24
__ftrunc2:
   sec
   ror  r24
   ror  r27
   ror  r26
   dec  r25
   brne __ftrunc2
   and  r30,r26
   and  r31,r27
   and  r22,r24
   rjmp __ftrunc1
__ftrunc0:
   clt
   clr  r23
   clr  r30
   clr  r31
   clr  r22
__ftrunc1:
   cbr  r22,0x80
   lsr  r23
   brcc __ftrunc3
   sbr  r22,0x80
__ftrunc3:
   bld  r23,7
   ld   r26,y+
   ld   r27,y+
   ld   r24,y+
   ld   r25,y+
   cp   r30,r26
   cpc  r31,r27
   cpc  r22,r24
   cpc  r23,r25
   bst  r25,7
   ret
_floor:
	CALL SUBOPT_0x6
	CALL SUBOPT_0x82
    brne __floor1
__floor0:
	CALL SUBOPT_0x5
	RJMP _0x20A0002
__floor1:
    brtc __floor0
	CALL SUBOPT_0x83
	CALL SUBOPT_0x22
	RJMP _0x20A0002
_ceil:
	CALL SUBOPT_0x6
	CALL SUBOPT_0x82
    brne __ceil1
__ceil0:
	CALL SUBOPT_0x5
	RJMP _0x20A0002
__ceil1:
    brts __ceil0
	CALL SUBOPT_0x5
	CALL SUBOPT_0x5D
	RJMP _0x20A0002
_sin:
	SBIW R28,4
	ST   -Y,R17
	LDI  R17,0
	CALL SUBOPT_0x84
	__GETD1N 0x3E22F983
	CALL __MULF12
	CALL SUBOPT_0x85
	CALL SUBOPT_0x86
	CALL __PUTPARD1
	RCALL _floor
	CALL SUBOPT_0x84
	CALL SUBOPT_0x12
	CALL SUBOPT_0x85
	CALL SUBOPT_0x87
	CALL __CMPF12
	BREQ PC+2
	BRCC PC+3
	JMP  _0x2000017
	CALL SUBOPT_0x87
	CALL SUBOPT_0x12
	CALL SUBOPT_0x85
	LDI  R17,LOW(1)
_0x2000017:
	CALL SUBOPT_0x84
	__GETD1N 0x3E800000
	CALL __CMPF12
	BREQ PC+2
	BRCC PC+3
	JMP  _0x2000018
	CALL SUBOPT_0x87
	CALL __SUBF12
	CALL SUBOPT_0x85
_0x2000018:
	CPI  R17,0
	BREQ _0x2000019
	CALL SUBOPT_0x86
	CALL __ANEGF1
	CALL SUBOPT_0x85
_0x2000019:
	CALL SUBOPT_0x86
	CALL SUBOPT_0x84
	CALL __MULF12
	__PUTD1S 1
	__GETD2N 0x4226C4B1
	CALL __MULF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x422DE51D
	CALL SUBOPT_0x12
	CALL SUBOPT_0x88
	__GETD2N 0x4104534C
	CALL __ADDF12
	CALL SUBOPT_0x84
	CALL __MULF12
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	__GETD1S 1
	__GETD2N 0x3FDEED11
	CALL __ADDF12
	CALL SUBOPT_0x88
	__GETD2N 0x3FA87B5E
	CALL __ADDF12
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __DIVF21
	LDD  R17,Y+0
	ADIW R28,9
	RET
_cos:
	CALL SUBOPT_0x83
	__GETD1N 0x3FC90FDB
	CALL SUBOPT_0x33
	RJMP _0x20A0002
_xatan:
	SBIW R28,4
	__GETD1S 4
	CALL SUBOPT_0x89
	__PUTD1S 0
	CALL SUBOPT_0x5
	__GETD2N 0x40CBD065
	CALL SUBOPT_0x8A
	CALL SUBOPT_0x89
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x5
	__GETD2N 0x41296D00
	CALL __ADDF12
	CALL SUBOPT_0x83
	CALL SUBOPT_0x8A
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL __DIVF21
	ADIW R28,8
	RET
_yatan:
	CALL SUBOPT_0x83
	__GETD1N 0x3ED413CD
	CALL __CMPF12
	BRSH _0x2000020
	CALL SUBOPT_0x6
	RCALL _xatan
	RJMP _0x20A0002
_0x2000020:
	CALL SUBOPT_0x83
	__GETD1N 0x401A827A
	CALL __CMPF12
	BREQ PC+2
	BRCC PC+3
	JMP  _0x2000021
	CALL SUBOPT_0x5
	CALL SUBOPT_0x21
	CALL SUBOPT_0x8B
	__GETD2N 0x3FC90FDB
	CALL SUBOPT_0x12
	RJMP _0x20A0002
_0x2000021:
	CALL SUBOPT_0x83
	CALL SUBOPT_0x22
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x5
	CALL SUBOPT_0x5D
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x8B
	__GETD2N 0x3F490FDB
	CALL __ADDF12
	RJMP _0x20A0002
_atan:
	LDD  R26,Y+3
	TST  R26
	BRMI _0x200002C
	CALL SUBOPT_0x6
	RCALL _yatan
	RJMP _0x20A0002
_0x200002C:
	CALL SUBOPT_0x5
	CALL __ANEGF1
	CALL __PUTPARD1
	RCALL _yatan
	CALL __ANEGF1
_0x20A0002:
	ADIW R28,4
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG

	.CSEG
__lcd_delay_G101:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
	RCALL __lcd_delay_G101
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G101
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G101
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G101
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G101:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G101
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G101
	RET
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf0 | (1<<__lcd_rs) | (1<<__lcd_rd) | (1<<__lcd_enable) ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G101
    ld    r26,y
    swap  r26
	RCALL __lcd_write_nibble_G101
    sbi   __lcd_port,__lcd_rd     ;RD=1
	JMP  _0x20A0001
__lcd_read_nibble_G101:
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G101
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G101
    andi  r30,0xf0
	RET
_lcd_read_byte0_G101:
	CALL __lcd_delay_G101
	RCALL __lcd_read_nibble_G101
    mov   r26,r30
	RCALL __lcd_read_nibble_G101
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	CALL __lcd_ready
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G101)
	SBCI R31,HIGH(-__base_y_G101)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	ST   -Y,R30
	CALL __lcd_write_data
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
	ADIW R28,2
	RET
_lcd_clear:
	CALL __lcd_ready
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL __lcd_ready
	LDI  R30,LOW(12)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL __lcd_ready
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL __lcd_write_data
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R26,R30
	BRLO _0x2020004
	__lcd_putchar1:
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R30,__lcd_y
	ST   -Y,R30
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x2020004:
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	JMP  _0x20A0001
_lcd_putsf:
	ST   -Y,R17
_0x2020008:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x202000A
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x2020008
_0x202000A:
	LDD  R17,Y+0
	ADIW R28,3
	RET
__long_delay_G101:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G101:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	CALL __lcd_write_nibble_G101
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RJMP _0x20A0001
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G101,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G101,3
	CALL SUBOPT_0x8C
	CALL SUBOPT_0x8C
	CALL SUBOPT_0x8C
	RCALL __long_delay_G101
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G101
	RCALL __long_delay_G101
	LDI  R30,LOW(40)
	CALL SUBOPT_0x8D
	LDI  R30,LOW(4)
	CALL SUBOPT_0x8D
	LDI  R30,LOW(133)
	CALL SUBOPT_0x8D
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	CALL _lcd_read_byte0_G101
	CPI  R30,LOW(0x5)
	BREQ _0x202000B
	LDI  R30,LOW(0)
	RJMP _0x20A0001
_0x202000B:
	CALL __lcd_ready
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL _lcd_clear
	LDI  R30,LOW(1)
_0x20A0001:
	ADIW R28,1
	RET

	.CSEG

	.DSEG

	.CSEG

	.CSEG

	.CSEG

	.ESEG
_P2:
	.DB  LOW(0x40C90FDB),HIGH(0x40C90FDB),BYTE3(0x40C90FDB),BYTE4(0x40C90FDB)
_DR:
	.DB  LOW(0x3C8EFA35),HIGH(0x3C8EFA35),BYTE3(0x3C8EFA35),BYTE4(0x3C8EFA35)
_K1:
	.DB  LOW(0x3E866882),HIGH(0x3E866882),BYTE3(0x3E866882),BYTE4(0x3E866882)
_days_month:
	.DB  LOW(0x1E1F1C1F),HIGH(0x1E1F1C1F),BYTE3(0x1E1F1C1F),BYTE4(0x1E1F1C1F)
	.DB  LOW(0x1F1F1E1F),HIGH(0x1F1F1E1F),BYTE3(0x1F1F1E1F),BYTE4(0x1F1F1E1F)
	.DB  LOW(0x1F1E1F1E),HIGH(0x1F1E1F1E),BYTE3(0x1F1E1F1E),BYTE4(0x1F1E1F1E)

	.DSEG
_Y:
	.BYTE 0x4
_M:
	.BYTE 0x4
_H:
	.BYTE 0x4
_B5:
	.BYTE 0x4
_J3:
	.BYTE 0x4
_H3:
	.BYTE 0x4
_M3:
	.BYTE 0x4
_C0:
	.BYTE 0x4
_MM:
	.BYTE 0x8
_HH:
	.BYTE 0x8
_cc:
	.BYTE 0x2
_day:
	.BYTE 0x2
_aA:
	.BYTE 0x8
_aD:
	.BYTE 0x8
_L5:
	.BYTE 0x4
_Z:
	.BYTE 0x4
_Z0:
	.BYTE 0x4
_Z1:
	.BYTE 0x4
_D:
	.BYTE 0x4
_A5:
	.BYTE 0x4
_D5:
	.BYTE 0x4
_R5:
	.BYTE 0x4
_T:
	.BYTE 0x4
_T0:
	.BYTE 0x4
_TT:
	.BYTE 0x4
_T3:
	.BYTE 0x4
_L0:
	.BYTE 0x4
_L2:
	.BYTE 0x4
_H0:
	.BYTE 0x4
_H1:
	.BYTE 0x4
_H2:
	.BYTE 0x4
_lat:
	.BYTE 0x4
_M8:
	.BYTE 0x4
_W8:
	.BYTE 0x4
_A:
	.BYTE 0x4
_B:
	.BYTE 0x4
_A0:
	.BYTE 0x4
_D0:
	.BYTE 0x4
_A2:
	.BYTE 0x4
_D1:
	.BYTE 0x4
_D2:
	.BYTE 0x4
_DA:
	.BYTE 0x4
_DD:
	.BYTE 0x4
_E:
	.BYTE 0x4
_F:
	.BYTE 0x4
_J:
	.BYTE 0x4
_S:
	.BYTE 0x4
_C:
	.BYTE 0x4
_P:
	.BYTE 0x4
_L:
	.BYTE 0x4
_G:
	.BYTE 0x4
_V:
	.BYTE 0x4
_U:
	.BYTE 0x4
_W:
	.BYTE 0x4
_V0:
	.BYTE 0x4
_V1:
	.BYTE 0x4
_V2:
	.BYTE 0x4
_delim:
	.BYTE 0x1
__base_y_G101:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1
__seed_G102:
	.BYTE 0x4
_p_S1040024:
	.BYTE 0x2

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x0:
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES, CODE SIZE REDUCTION:61 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0x3:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_putsf

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4:
	__GETD2N 0x0
	__PUTDZ2 0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0x5:
	__GETD1S 0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x6:
	RCALL SUBOPT_0x5
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x7:
	MOVW R30,R16
	LDI  R26,LOW(_HH)
	LDI  R27,HIGH(_HH)
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETD1P
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:87 WORDS
SUBOPT_0x8:
	CALL __DIVD21
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	CALL __MODD21
	__ADDD1N 48
	ST   -Y,R30
	JMP  _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x9:
	CALL __MODD21
	__ADDD1N 48
	ST   -Y,R30
	JMP  _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0xA:
	MOVW R30,R16
	LDI  R26,LOW(_MM)
	LDI  R27,HIGH(_MM)
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETD1P
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0xA
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xB:
	__GETD1N 0x3F800000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0xC:
	STS  _G,R30
	STS  _G+1,R31
	STS  _G+2,R22
	STS  _G+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:57 WORDS
SUBOPT_0xD:
	LDS  R26,_Y
	LDS  R27,_Y+1
	LDS  R24,_Y+2
	LDS  R25,_Y+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xE:
	LDS  R30,_D
	LDS  R31,_D+1
	LDS  R22,_D+2
	LDS  R23,_D+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0xF:
	CALL __PUTPARD1
	JMP  _Trunc

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x10:
	LDS  R26,_D1
	LDS  R27,_D1+1
	LDS  R24,_D1+2
	LDS  R25,_D1+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x11:
	__GETD1N 0x3F000000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 26 TIMES, CODE SIZE REDUCTION:47 WORDS
SUBOPT_0x12:
	CALL __SWAPD12
	CALL __SUBF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x13:
	STS  _F,R30
	STS  _F+1,R31
	STS  _F+2,R22
	STS  _F+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:27 WORDS
SUBOPT_0x14:
	LDS  R30,_M
	LDS  R31,_M+1
	LDS  R22,_M+2
	LDS  R23,_M+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x15:
	CALL __DIVD21
	CALL __CDF1
	RJMP SUBOPT_0xF

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x16:
	CALL __MULD12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x17:
	LDS  R26,_G
	LDS  R27,_G+1
	LDS  R24,_G+2
	LDS  R25,_G+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x18:
	RCALL SUBOPT_0x14
	__SUBD1N 9
	CALL __CDF1
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x19:
	CALL __CWD1
	CALL __CDF1
	CALL __PUTDP1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1A:
	STS  _A,R30
	STS  _A+1,R31
	STS  _A+2,R22
	STS  _A+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:63 WORDS
SUBOPT_0x1B:
	LDS  R26,_S
	LDS  R27,_S+1
	LDS  R24,_S+2
	LDS  R25,_S+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1C:
	STS  _J3,R30
	STS  _J3+1,R31
	STS  _J3+2,R22
	STS  _J3+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x1D:
	LDS  R26,_J
	LDS  R27,_J+1
	LDS  R24,_J+2
	LDS  R25,_J+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1E:
	CALL __ADDF12
	STS  _J,R30
	STS  _J+1,R31
	STS  _J+2,R22
	STS  _J+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:27 WORDS
SUBOPT_0x1F:
	LDS  R30,_G
	LDS  R31,_G+1
	LDS  R22,_G+2
	LDS  R23,_G+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0x20:
	__GETD2N 0x40000000
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x21:
	__GETD2N 0x3F800000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x22:
	RCALL SUBOPT_0xB
	RJMP SUBOPT_0x12

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x23:
	LDS  R26,_T
	LDS  R27,_T+1
	LDS  R24,_T+2
	LDS  R25,_T+3
	__GETD1N 0x470EAD00
	CALL __DIVF21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x24:
	STS  _T0,R30
	STS  _T0+1,R31
	STS  _T0+2,R22
	STS  _T0+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x25:
	CALL __ADDF12
	STS  _S,R30
	STS  _S+1,R31
	STS  _S+2,R22
	STS  _S+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x26:
	LDS  R30,_Z0
	LDS  R31,_Z0+1
	LDS  R22,_Z0+2
	LDS  R23,_Z0+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:29 WORDS
SUBOPT_0x27:
	CALL __DIVF21
	STS  _S,R30
	STS  _S+1,R31
	STS  _S+2,R22
	STS  _S+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x28:
	CALL __CDF1
	RJMP SUBOPT_0x12

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x29:
	STS  _S,R30
	STS  _S+1,R31
	STS  _S+2,R22
	STS  _S+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2A:
	LDI  R26,LOW(_DR)
	LDI  R27,HIGH(_DR)
	CALL __EEPROMRDD
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x2B:
	LDS  R30,_T
	LDS  R31,_T+1
	LDS  R22,_T+2
	LDS  R23,_T+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x2C:
	STS  _L,R30
	STS  _L+1,R31
	STS  _L+2,R22
	STS  _L+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2D:
	RCALL SUBOPT_0xC
	LDS  R30,_L
	LDS  R31,_L+1
	LDS  R22,_L+2
	LDS  R23,_L+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x2E:
	LDS  R26,_L
	LDS  R27,_L+1
	LDS  R24,_L+2
	LDS  R25,_L+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2F:
	LDI  R26,LOW(_P2)
	LDI  R27,HIGH(_P2)
	CALL __EEPROMRDD
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:23 WORDS
SUBOPT_0x30:
	CALL __PUTPARD1
	JMP  _sin

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x31:
	STS  _V,R30
	STS  _V+1,R31
	STS  _V+2,R22
	STS  _V+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x32:
	LDS  R30,_L
	LDS  R31,_L+1
	LDS  R22,_L+2
	LDS  R23,_L+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x33:
	CALL __SUBF12
	RJMP SUBOPT_0x30

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x34:
	CALL __MULF12
	LDS  R26,_V
	LDS  R27,_V+1
	LDS  R24,_V+2
	LDS  R25,_V+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x35:
	LDS  R30,_TT
	LDS  R31,_TT+1
	LDS  R22,_TT+2
	LDS  R23,_TT+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x36:
	CALL __PUTPARD1
	JMP  _cos

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x37:
	CALL __MULF12
	RCALL SUBOPT_0x21
	RJMP SUBOPT_0x12

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x38:
	STS  _U,R30
	STS  _U+1,R31
	STS  _U+2,R22
	STS  _U+3,R23
	RJMP SUBOPT_0x32

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x39:
	CALL __MULF12
	LDS  R26,_U
	LDS  R27,_U+1
	LDS  R24,_U+2
	LDS  R25,_U+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x3A:
	STS  _W,R30
	STS  _W+1,R31
	STS  _W+2,R22
	STS  _W+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x3B:
	CALL __MULF12
	LDS  R26,_W
	LDS  R27,_W+1
	LDS  R24,_W+2
	LDS  R25,_W+3
	CALL __ADDF12
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0x32
	RJMP SUBOPT_0x20

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x3C:
	CALL __MULF12
	LDS  R26,_W
	LDS  R27,_W+1
	LDS  R24,_W+2
	LDS  R25,_W+3
	RJMP SUBOPT_0x12

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3D:
	LDS  R26,_V
	LDS  R27,_V+1
	LDS  R24,_V+2
	LDS  R25,_V+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x3E:
	CALL __PUTPARD1
	JMP  _sqrt

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3F:
	RCALL SUBOPT_0x1B
	CALL __DIVF21
	CALL __PUTPARD1
	JMP  _atan

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x40:
	LDS  R30,_U
	LDS  R31,_U+1
	LDS  R22,_U+2
	LDS  R23,_U+3
	RJMP SUBOPT_0x3E

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x41:
	LD   R26,Y
	LDD  R27,Y+1
	CALL __CWD2
	CALL __CDF2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x42:
	LDS  R30,_H0
	LDS  R31,_H0+1
	LDS  R22,_H0+2
	LDS  R23,_H0+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x43:
	CALL __ADDF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x40000000
	CALL __DIVF21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x44:
	LDS  R30,_D0
	LDS  R31,_D0+1
	LDS  R22,_D0+2
	LDS  R23,_D0+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x45:
	RCALL SUBOPT_0x1B
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x46:
	LDS  R26,_C
	LDS  R27,_C+1
	LDS  R24,_C+2
	LDS  R25,_C+3
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x47:
	CALL __ADDF12
	LDS  R26,_Z
	LDS  R27,_Z+1
	LDS  R24,_Z+2
	LDS  R25,_Z+3
	CALL __SUBF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x48:
	STS  _V0,R30
	STS  _V0+1,R31
	STS  _V0+2,R22
	STS  _V0+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x49:
	LDS  R30,_D2
	LDS  R31,_D2+1
	LDS  R22,_D2+2
	LDS  R23,_D2+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x4A:
	LDS  R30,_V0
	LDS  R31,_V0+1
	LDS  R22,_V0+2
	LDS  R23,_V0+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x4B:
	LDS  R30,_V2
	LDS  R31,_V2+1
	LDS  R22,_V2+2
	LDS  R23,_V2+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4C:
	LDS  R30,_D1
	LDS  R31,_D1+1
	LDS  R22,_D1+2
	LDS  R23,_D1+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x4D:
	LDS  R30,_V1
	LDS  R31,_V1+1
	LDS  R22,_V1+2
	LDS  R23,_V1+3
	__GETD2N 0x40800000
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x4E:
	LDS  R26,_V2
	LDS  R27,_V2+1
	LDS  R24,_V2+2
	LDS  R25,_V2+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x4F:
	LDS  R30,_B
	LDS  R31,_B+1
	LDS  R22,_B+2
	LDS  R23,_B+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x50:
	LDS  R30,_A
	LDS  R31,_A+1
	LDS  R22,_A+2
	LDS  R23,_A+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x51:
	LDS  R26,_V0
	LDS  R27,_V0+1
	LDS  R24,_V0+2
	LDS  R25,_V0+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x52:
	STS  _D,R30
	STS  _D+1,R31
	STS  _D+2,R22
	STS  _D+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x53:
	RCALL SUBOPT_0x4F
	CALL __ANEGF1
	LDS  R26,_D
	LDS  R27,_D+1
	LDS  R24,_D+2
	LDS  R25,_D+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x54:
	CALL __DIVF21
	STS  _E,R30
	STS  _E+1,R31
	STS  _E+2,R22
	STS  _E+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x55:
	LDS  R30,_H3
	LDS  R31,_H3+1
	LDS  R22,_H3+2
	LDS  R23,_H3+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x56:
	LDS  R30,_M3
	LDS  R31,_M3+1
	LDS  R22,_M3+2
	LDS  R23,_M3+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x57:
	CLT
	BLD  R2,0
	JMP  _cld_cls

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x58:
	LDS  R30,_lat
	LDS  R31,_lat+1
	LDS  R22,_lat+2
	LDS  R23,_lat+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x59:
	STS  _L5,R30
	STS  _L5+1,R31
	STS  _L5+2,R22
	STS  _L5+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x5A:
	LDS  R30,_H
	LDS  R31,_H+1
	LDS  R22,_H+2
	LDS  R23,_H+3
	CALL __CDF1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5B:
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x41C00000
	CALL __DIVF21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x5C:
	CALL __ADDF12
	STS  _T,R30
	STS  _T+1,R31
	STS  _T+2,R22
	STS  _T+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5D:
	RCALL SUBOPT_0x21
	CALL __ADDF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x5E:
	CALL _PosOfSun
	LDS  R30,_A5
	LDS  R31,_A5+1
	LDS  R22,_A5+2
	LDS  R23,_A5+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x5F:
	LDS  R30,_D5
	LDS  R31,_D5+1
	LDS  R22,_D5+2
	LDS  R23,_D5+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x60:
	__PUTD1MN _aA,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x61:
	__GETD2MN _aA,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x62:
	LDS  R30,_aA
	LDS  R31,_aA+1
	LDS  R22,_aA+2
	LDS  R23,_aA+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x63:
	LDS  R26,_B5
	LDS  R27,_B5+1
	LDS  R24,_B5+2
	LDS  R25,_B5+3
	CALL __CDF2
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x64:
	STS  _A0,R30
	STS  _A0+1,R31
	STS  _A0+2,R22
	STS  _A0+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x65:
	STS  _D0,R30
	STS  _D0+1,R31
	STS  _D0+2,R22
	STS  _D0+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x66:
	LDS  R26,_aA
	LDS  R27,_aA+1
	LDS  R24,_aA+2
	LDS  R25,_aA+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x67:
	LDS  R26,_aD
	LDS  R27,_aD+1
	LDS  R24,_aD+2
	LDS  R25,_aD+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x68:
	LDS  R26,_P
	LDS  R27,_P+1
	LDS  R24,_P+2
	LDS  R25,_P+3
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x69:
	CALL __GETD1P_INC
	__SUBD1N -1
	CALL __PUTDP1_DEC
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6A:
	CALL __PUTPARD1
	JMP  _Abs

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x6B:
	MOVW R26,R16
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21U
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21U
	ADIW R30,48
	ST   -Y,R30
	CALL _lcd_putchar
	MOVW R26,R16
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21U
	ADIW R30,48
	ST   -Y,R30
	JMP  _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x6C:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x6D:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	ADIW R30,48
	ST   -Y,R30
	JMP  _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x6E:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	ADIW R30,48
	ST   -Y,R30
	JMP  _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x6F:
	LDS  R26,_day
	LDS  R27,_day+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x70:
	LDS  R26,_M
	LDS  R27,_M+1
	LDS  R24,_M+2
	LDS  R25,_M+3
	__GETD1N 0xA
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x71:
	RCALL SUBOPT_0xD
	__GETD1N 0xA
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x72:
	LDS  R26,_M
	LDS  R27,_M+1
	LDS  R24,_M+2
	LDS  R25,_M+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x73:
	RCALL SUBOPT_0xD
	__GETD1N 0x4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x74:
	__GETD1MN _HH,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x75:
	LDS  R26,_HH
	LDS  R27,_HH+1
	LDS  R24,_HH+2
	LDS  R25,_HH+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x76:
	__GETD1MN _MM,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x77:
	LDS  R26,_MM
	LDS  R27,_MM+1
	LDS  R24,_MM+2
	LDS  R25,_MM+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x78:
	__GETW2R 7,8
	LDI  R30,LOW(60)
	LDI  R31,HIGH(60)
	CALL __MULW12
	ADD  R30,R9
	ADC  R31,R10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x79:
	CALL _me_delay
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7A:
	LDI  R30,LOW(6)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x7B:
	LDS  R26,_B5
	LDS  R27,_B5+1
	LDS  R24,_B5+2
	LDS  R25,_B5+3
	__GETD1N 0xA
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x7C:
	MOV  R30,R6
	MOV  R26,R5
	CALL __EQB12
	MOV  R0,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x7D:
	LDS  R26,_B5
	LDS  R27,_B5+1
	LDS  R24,_B5+2
	LDS  R25,_B5+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x7E:
	MOV  R30,R3
	MOV  R26,R5
	CALL __EQB12
	MOV  R0,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x7F:
	CALL __GETD1P_INC
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
	CALL __PUTDP1_DEC
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x80:
	CALL _display
	RJMP SUBOPT_0x7C

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x81:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CALL __GTW12
	AND  R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x82:
	CALL _ftrunc
	__PUTD1S 0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x83:
	__GETD2S 0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x84:
	__GETD2S 5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x85:
	__PUTD1S 5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x86:
	__GETD1S 5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x87:
	RCALL SUBOPT_0x84
	RJMP SUBOPT_0x11

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x88:
	__GETD2S 1
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x89:
	__GETD2S 4
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x8A:
	CALL __MULF12
	__GETD2N 0x414A8F4E
	CALL __ADDF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8B:
	CALL __DIVF21
	CALL __PUTPARD1
	JMP  _xatan

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x8C:
	CALL __long_delay_G101
	LDI  R30,LOW(48)
	ST   -Y,R30
	JMP  __lcd_init_write_G101

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x8D:
	ST   -Y,R30
	CALL __lcd_write_data
	JMP  __long_delay_G101


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xBB8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

_sqrt:
	sbiw r28,4
	push r21
	ldd  r25,y+7
	tst  r25
	brne __sqrt0
	adiw r28,8
	rjmp __zerores
__sqrt0:
	brpl __sqrt1
	adiw r28,8
	rjmp __maxres
__sqrt1:
	push r20
	ldi  r20,66
	ldd  r24,y+6
	ldd  r27,y+5
	ldd  r26,y+4
__sqrt2:
	st   y,r24
	std  y+1,r25
	std  y+2,r26
	std  y+3,r27
	movw r30,r26
	movw r22,r24
	ldd  r26,y+4
	ldd  r27,y+5
	ldd  r24,y+6
	ldd  r25,y+7
	rcall __divf21
	ld   r24,y
	ldd  r25,y+1
	ldd  r26,y+2
	ldd  r27,y+3
	rcall __addf12
	rcall __unpack1
	dec  r23
	rcall __repack
	ld   r24,y
	ldd  r25,y+1
	ldd  r26,y+2
	ldd  r27,y+3
	eor  r26,r30
	andi r26,0xf8
	brne __sqrt4
	cp   r27,r31
	cpc  r24,r22
	cpc  r25,r23
	breq __sqrt3
__sqrt4:
	dec  r20
	breq __sqrt3
	movw r26,r30
	movw r24,r22
	rjmp __sqrt2
__sqrt3:
	pop  r20
	pop  r21
	adiw r28,8
	ret

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__CWD2:
	MOV  R24,R27
	ADD  R24,R24
	SBC  R24,R24
	MOV  R25,R24
	RET

__EQB12:
	CP   R30,R26
	LDI  R30,1
	BREQ __EQB12T
	CLR  R30
__EQB12T:
	RET

__LTW12:
	CP   R26,R30
	CPC  R27,R31
	LDI  R30,1
	BRLT __LTW12T
	CLR  R30
__LTW12T:
	RET

__GTW12:
	CP   R30,R26
	CPC  R31,R27
	LDI  R30,1
	BRLT __GTW12T
	CLR  R30
__GTW12T:
	RET

__LTW12U:
	CP   R26,R30
	CPC  R27,R31
	LDI  R30,1
	BRLO __LTW12UT
	CLR  R30
__LTW12UT:
	RET

__GTW12U:
	CP   R30,R26
	CPC  R31,R27
	LDI  R30,1
	BRLO __GTW12UT
	CLR  R30
__GTW12UT:
	RET

__LTD12:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R25,R23
	LDI  R30,1
	BRLT __LTD12T
	CLR  R30
__LTD12T:
	RET

__GTD12:
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	CPC  R23,R25
	LDI  R30,1
	BRLT __GTD12T
	CLR  R30
__GTD12T:
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__MULD12:
	RCALL __CHKSIGND
	RCALL __MULD12U
	BRTC __MULD121
	RCALL __ANEGD1
__MULD121:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__DIVD21:
	RCALL __CHKSIGND
	RCALL __DIVD21U
	BRTC __DIVD211
	RCALL __ANEGD1
__DIVD211:
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__MODD21:
	CLT
	SBRS R25,7
	RJMP __MODD211
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	SUBI R26,-1
	SBCI R27,-1
	SBCI R24,-1
	SBCI R25,-1
	SET
__MODD211:
	SBRC R23,7
	RCALL __ANEGD1
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	BRTC __MODD212
	RCALL __ANEGD1
__MODD212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__CHKSIGND:
	CLT
	SBRS R23,7
	RJMP __CHKSD1
	RCALL __ANEGD1
	SET
__CHKSD1:
	SBRS R25,7
	RJMP __CHKSD2
	CLR  R0
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	ADIW R26,1
	ADC  R24,R0
	ADC  R25,R0
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSD2:
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__GETD1P_INC:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X+
	RET

__PUTDP1:
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	RET

__PUTDP1_DEC:
	ST   -X,R23
	ST   -X,R22
	ST   -X,R31
	ST   -X,R30
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__CDF2U:
	SET
	RJMP __CDF2U0
__CDF2:
	CLT
__CDF2U0:
	RCALL __SWAPD12
	RCALL __CDF1U0

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__EEPROMRDD:
	ADIW R26,2
	RCALL __EEPROMRDW
	MOVW R22,R30
	SBIW R26,2

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__ANEGF1:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __ANEGF10
	SUBI R23,0x80
__ANEGF10:
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF129
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__LTF12:
	RCALL __CMPF12
	LDI  R30,1
	BREQ __LTF120
	BRCS __LTF121
__LTF120:
	CLR  R30
__LTF121:
	RET

__GTF12:
	RCALL __CMPF12
	LDI  R30,1
	BREQ __GTF120
	BRCC __GTF121
__GTF120:
	CLR  R30
__GTF121:
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__CPD02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	CPC  R0,R24
	CPC  R0,R25
	RET

__CPD12:
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	CPC  R23,R25
	RET

;END OF CODE MARKER
__END_OF_CODE:
